program beispiel;

{
 Beispiel 4 (PASCAL) : Definieren eines Drucker-Buffers und
                       Ausgabe einer Datei ueber Buffer an
                       die Drucker-Schnittstelle
}

(*$IMLABLIB.PAS*)                                (* Einbinden der PASCAL-Bibliotheken *)

procedure Demodrucker;
var                                              (* Variablendeklaration *)
   groesse,                                      (* Groesse des Buffers *)
   status : byte;                                (* Status des Druckerbuffers *)
   ch : char;                                    (* ASCII-Zeichen *)
   k : real;                                     (* Anzahl der freien Bytes *)
   textdatei : text;                             (* Text-Datei *)

procedure anzahl;                                (* Ermitteln der Anzahl der freien Byte
                                                    im Drucker-Buffer *)
begin
  repeat
    mlprnbufstat(err,status);                    (* Lesen des Status des Drucker-Buffers *)
    if status <> 0 then                          (* Analyse des Status : *)
      if status < 128 then
        k := status                              (* Status gleich Anzahl *)
      else
        k := 128;                                (* Status koennte weiter ausgewertet werden *)
                                                 (* siehe Kapitel 5.4 *)
  until status <> 0;                             (* solange abfragen bis Status <> 0 *)
end;

begin
  mladr := $380;                                 (* Basisadresse gleich $380 setzen *)
  delaystat := 2000;                             (* Schleifenzaehler *)
  mlgetbuf(err,groesse);                         (* Groesse des Drucker-Buffers
                                                    auf der Multi-LAB Karte ermitteln *)
  if groesse = 0 then                            (* Wenn die Groesse gleich Null ist, *)
    begin                                        (* ist der Drucker-Buffer noch nicht definiert : *)
      groesse := 128;                            (* Drucker-Buffer definieren (32 K) : *)
      mlsetbuf(err,groesse);                     (* Es wird davon ausgegangen, dass *)
    end;                                         (* 32 K freies RAM zur Verfuegung stehen *)
  anzahl;                                        (* Ermitteln der Anzahl der freien Byte
                                                    im Drucker-Buffer *)
  assign(textdatei,'beisp4.pas');                (* Einlesen des Namens der Datei und *)
  reset(textdatei);                              (* Oeffnen der Datei *)
  while not eof(textdatei) do                    (* Datei bis zum Ende lesen *)
    begin
      read(textdatei,ch);                        (* Zeichen von der Textdatei einlesen *)
      mlprnbufwrite(err,ch);                     (* Zeichen aus Textdatei senden *)
      if k = 0 then                              (* Anzahl gleich 0 : *)
        anzahl                                   (* Ermitteln der Anzahl der freien Byte *)
      else
        k := k - 1;                              (* sonst : Anzahl dekrementieren *)
    end;
end;

begin
  demodrucker;
end.
