/*
 Beispiel 5 (C) : Fortlaufende Messung von 4 Analog-
                  eingaengen, 1000 Messwerte je Kanal,
                  Abtastrate 200 us = 5 KHz.
                  Start der Messung ueber den externen
                  Triggereingang INT-0.
                  Verwendet wird das Messprogramm 84.
                                                       */

extern int err,mladr;   /* Fehlercode und Basisadresse von Multi-LAB */

extern mlinstro();      /* Multi-Tasking-ROM-Programm installieren */
extern mlverbin();      /* Multi-Tasking Programme verbinden */
extern mlwaehle();      /* Task anwaehlen */
extern mldrunpr();      /* Prozedur starten */
extern mldbsetp();      /* Parameter setzen */
extern mldbgetp();      /* Parameter lesen */
extern mltsetda();      /* Datenpointer setzen */
extern mltblre();       /* Datenblock lesen */

int parameter[11],            /* Parameterberich */
    datarray[4000],           /* Datenbereich */
    i,                        /* Laufvariable */
    messung,                  /* Schalter fuer Messung */
    status;                   /* Status der Messung */
main()
{
  mladr = 0x380;              /* Basisadresse setzen */
  mlreset(&err);              /* Reset der Multi-LAB Karte */
  messung = 0;                /* Messung laeuft noch nicht ! */

  for (i = 0;i < 100; i++);   /* Delay */

                             /* Parameter setzen */
  parameter[1] = 10; parameter[2] = 4; parameter[3] = 1;
  parameter[4] = 1; parameter[5] = 0; parameter[6] = 0;
  parameter[7] = 4; parameter[8] = 0; parameter[9] = 232;
  parameter[10] = 3;

  /* Folgende drei Prozeduraufrufe sind bei mehrmaligem Aufruf des Programms
     nur beim ersten Mal erforderlich !! */

  mlinstro(&err,7,84,8000);   /* Installieren des Messprogramms 84 (Task 7) und
                                 Reservieren von 8000 Byte fuer Daten */

  mlinstro(&err,0,81,0);      /* Installieren des Triggerprogramms INT-0 (Task 0) */
  mlverbin(&err,0,7);         /* Verbinden beider Tasks */

  /* Bei mehrmaligem Aufruf des Programms immer erforderlich !! */

  mlwaehle(&err,7);           /* Anwaehlen der Task des Messprogramms fuer nachfolgende Befehle */

  for (i = 1;i < 11; i++)
    mldbsetp(&err,i,parameter[i]); /* Setzen der Parameter fuer das Messprogramm */

  mldrunpr(&err,6);           /* Aktivieren der Parameter und des Triggers mit Prozedur 6 */
                              /* Starten des Programms durch externen Triggerimpuls am
                                 Eingang INT-0 */

  printf("Messprogramme installiert und Parameter gesetzt\n\n");
  printf("Trigger an Eingang INT-0 ausloesen\n");

  do {                        /* Warten bis Status = 3 : Messung beendet */
    status = mldbgetp(&err,0);
    if (messung == 0) {
      if (status == 2) {
        printf("Trigger ausgeloest\n");
        messung = 1;
      }
    }
  } while (status != 3);
  printf("Messung beendet\n");
  mltsetda(&err,7,0);         /* Daten-Pointer auf 0 setzen */
  mltblre(&err,7,8000,&datarray); /* Abholen der Daten von der Multi-LAB Karte und
                                   Schreiben der Daten in den Datenbereich DATARRAY */
}
