program beispiel;

{
 Beispiel 5 (PASCAL) : Fortlaufende Messung von 4 Analog-
                       eingaengen, 1000 Messwerte je Kanal,
                       Abtastrate 200 us = 5 KHz.
                       Start der Messung ueber den externen
                       Triggereingang INT-0.
                       Verwendet wird das Messprogramm 84.
}

type
    arr = array[1..8000] of byte;

(*$IMLABLIB.PAS*)                                (* Einbinden der PASCAL-Bibliotheken *)
(*$ITASKLIB.PAS*)

procedure mess84;
const                                            (* Konstantendeklaration *)
     parameter : array[1..10] of byte
                 = (10,4,1,1,0,0,4,0,232,3);

var                                              (* Variablendeklaration *)
   datarray : arr;                               (* Datenbereich *)
   daten : array[1..4000] of integer absolute datarray;
   i : integer;                                  (* Laufvariable *)
   status : byte;                                (* Status der Messung *)
   messung : boolean;                            (* Switch fuer Messung *)

begin
  mladr := $380;                                 (* Basisadresse gleich $380 setzen *)
  delaystat := 2000;                             (* Schleifenzaehler *)
  mlreset(err);                                  (* Reset der Multi-LAB Karte *)
  delay(200);                                    (* 200 ms Delay *)
  messung := false;                              (* Messung laeuft noch nicht ! *)

  (* Folgende drei Prozeduraufrufe sind bei mehrmaligem Aufruf des Programms
     nur beim ersten Mal erforderlich !! *)

  mlinsttask(err,7,84,8000);                     (* Installieren des Messprogramms 84 (Task 7) und
                                                    Reservieren von 8000 Byte fuer Daten *)

  mlinsttask(err,0,81,0);                        (* Installieren des Triggerprogramms INT-0 (Task 0) *)

  mlverbindetask(err,0,7);                       (* Verbinden beider Tasks *)

  (* Bei mehrmaligem Aufruf des Programms immer erforderlich !! *)

  mlwaehletask(err,7);                           (* Anwaehlen der Task des Messprogramms fuer nachfolgende Befehle *)

  for i := 1 to 10 do                            (* Setzen der Parameter fuer das Messprogramm *)
    mldsetparbytetask(err,i,parameter[i]);

  mldrunproc(err,6);                             (* Aktivieren der Parameter und des Triggers mit Prozedur 6 *)
                                                 (* Starten des Programms durch externen Triggerimpuls am
                                                    Eingang INT-0 *)

  writeln('Messprogramme installiert und Parameter gesetzt');
  writeln('Trigger an Eingang INT-0 ausloesen');

  repeat                                         (* Warten bis Status = 3 : Messung beendet *)
    status := mldgetparbytetask(err,0);
    if not messung then
      if status > 1 then
        begin
          writeln('Trigger ausgeloest');
          messung := true;
        end;
  until status = 3;
  writeln('Messung beendet');
  mlsetdatpoint(err,7,0);                        (* Daten-Pointer auf 0 setzen *)
  mltaskblockread(err,7,8000,datarray);          (* Abholen der Daten von der Multi-LAB Karte und
                                                    Schreiben der Daten in den Datenbereich DATARRAY *)

 for i := 1 to 4000 do
   write(daten[i] shr 4:5);
end;

begin
  mess84;
end.
