'
' Beispiel 5 (Turbo-BASIC) : Fortlaufende Messung von 4 Analog-
'                            eingaengen, 1000 Messwerte je Kanal,
'	                     Abtastrate 200 us = 5 KHz.
'                            Start der Messung ueber den externen
'                            Triggereingang INT-0.
'                            Verwendet wird das Messprogramm 84.


$INCLUDE "MLABLIB.BAS"                                ' Einbinden der BASIC-Bibliotheken
$INCLUDE "TASKLIB.BAS"

SUB mess84

                                                      ' Variablendeklaration
DIM datarray%(1:8000)                                 ' Datenbereich
SHARED mladr%,delaystat%
LOCAL i%                                  	      ' Laufvariable
LOCAL status%                                	      ' Status der Messung
LOCAL messung%                            	      ' Switch fuer Messung
LOCAL parameter%


  mladr% = &H380                                      ' Basisadresse gleich $380 setzen
  delaystat% = 2000                                   ' Schleifenzaehler
  call mlreset(ferr%)                                 ' Reset der Multi-LAB Karte
  delay(2)                                    	      ' 200 ms Delay
  messung% = 0                              	      ' Messung laeuft noch nicht !

  ' Folgende drei Prozeduraufrufe sind bei mehrmaligem Aufruf des Programms
  ' nur beim ersten Mal erforderlich !!

  call mlinsttask(ferr%,7,84,8000)                    ' Installieren des Messprogramms 84 (Task 7) und
                                                      ' Reservieren von 8000 Byte fuer Daten

  call mlinsttask(ferr%,0,81,0)                       ' Installieren des Triggerprogramms INT-0 (Task 0)

  call mlverbindetask(ferr%,0,7)                      ' Verbinden beider Tasks

  ' Bei mehrmaligem Aufruf des Programms immer erforderlich !!

  call mlwaehletask(ferr%,7)                          ' Anwaehlen der Task des Messprogramms fuer nachfolgende Befehle

  for i% = 1 to 10                                    ' Setzen der Parameter fuer das Messprogramm
    read parameter%
    call mldsetparbytetask(ferr%,i%,parameter%)
  next i%

  call mldrunproc(ferr%,6)                            ' Aktivieren der Parameter und des Triggers mit Prozedur 6
                                                      ' Starten des Programms durch externen Triggerimpuls am
                                                      ' Eingang INT-0

  print "Messprogramme installiert und Parameter gesetzt"
  print "Trigger an Eingang INT-0 ausloesen"

  status% = 0
  WHILE status% <> 3                                  ' Warten bis Status = 3 : Messung beendet
    status% = FNmldgetparbytetask(ferr%,0)
    if messung% = 0 then
      if status% > 1 then
        print "Trigger ausgeloest"
        messung% = 1
      end if
    end if
  WEND
  print "Messung beendet"
  call mlsetdatpoint(ferr%,7,0)                       ' Daten-Pointer auf 0 setzen
  call mltaskblockread(ferr%,7,8000,datarray%())      ' Abholen der Daten von der Multi-LAB Karte und
                                                      'Schreiben der Daten in den Datenbereich DATARRAY

 for i% = 1 to 4000
   print hex$(datarray%(i%));" ";
 next i%

END SUB


call mess84
						      ' Konstantendeklaration
DATA 10,4,1,1,0,0,4,0,232,3
