' Letzte Bearbeitung : 23.08.1989  11:30

' T u r b o - B A S I C  -  B I B L I O T H E K   fr die Makrobefehle
'
' der Multi-LAB Karte von SORCUS COMPUTER GmbH
'
' Version 1B          (nderungen vorbehalten)
'
' Getestet mit Turbo-BASIC Version 1.0
'
' Einschrnkungen : Integer Arrays (verwendet bei den Befehl mladshin,
'		    mltaskblockread, mltaskblockwrite) knnen nicht bis 64 K
'		    genutzt werden, wenn das Overflow Flag im Men Options
'		    gesetzt ist, da sonst eine Fehlermeldung ("Overflow") er-
'		    scheint :

'		    Beispiel : DIM arr%(1..32767)    'maximal erlaubte Gre
'		               arr%(16700) = 1	     'erzeugt Fehlermeldung !

'		    Wird das Overflow Flag nicht gesetzt, ist eine volle Nut-
'		    zung bis 64 K mglich.

'		    Beispiel : DIM arr%(1..32767)    'maximal erlaubt Gre
'			       arr%(16700) = 1	     'erzeugt keine Fehlermel-
'						      dung !


mladr% = &H380          'Basisadresse
delaystat% = 2000	'Zhler fr Statusabfrage
ferr% = 0		'Error-Byte                                        	

' Wandel-Routine : FNbyteint% = Highbyte * 256 + LowByte

DEF FNbyteint%(Hi%,Lo%)
LOCAL z&

  z& = Hi%
  z& = z& * 256 + Lo%
  if z& > 32767 then FNbyteint% = z& - 65536_
  		else FNbyteint% = z&

END DEF

' Fehler-Check und Fehlermeldungen

SUB ferror(ferr%)
LOCAL ch$

  IF (ferr% > 0) and (ferr% < 10) THEN
    print
    print
    print chr$(7);"*** Fehlermeldung von der Multi-LAB/1 Karte ***"
    print "*** Fehlercode : ";hex$(ferr%);" ***"
    print
  ELSEIF (ferr% = 254) or (ferr% = 255) THEN
    print
    print
    IF ferr% = 254 THEN
      print chr$(7);"*** Fehler  : Multi-LAB/1 sendet kein Byte zurck   ***"
    END IF
    IF ferr% = 255 THEN
      print chr$(7);"*** Fehler  : Multi-LAB/1 kann kein Byte empfangen  ***"
    END IF
    print "*** Ursache : Falsche Basisadresse eingestellt oder ***"
    print "***           Delay zu klein                        ***"
    print
  END IF

select case ferr%

  case 0
  case 1
  	print "Befehl ist ungltig"
  case 2
  	print "Befehl ist unvollstndig bertragen"
  case 3
  	print "Fehler bei der Ausfhrung des Befehls"
  case 4
  	print "Befehl ist noch nicht implementiert"
  case 5
  	print "Befehl kann nicht ausgefhrt werden, weil die Hardware nicht vorhanden ist"
  case 6
  	print "Mit dem Befehl wurde eine Funktionseinheit angesprochen, die bereits fr eine"
        print "andere Funktion benutzt wird. Befehl wurde deshalb nicht ausgefhrt"
  case 7
  	print "Die anfragende Schnittstelle ist nicht Host"
  case 8
  	print "Es ist kein Zeichen an der seriellen Schnittstelle empfangen worden"
  case 9
  	print "Die serielle Schnittstelle ist im Host-Mode"
  case ELSE
         print
         print
         print chr$(7);"***** Zurckgelieferter Befehlscode : ";hex$(ferr%);"H *****"
  END select
  IF ferr% > 0 THEN
    print
    ch$ = "N"
    print "Abbruch (J / N) [ N ] : "
    ch$ = input$(1)
    IF ucase$(CH$) = "J" THEN
      cls
      stop
    END IF
  END IF
END SUB

' Liegt ein Datenbyte von der Multi-LAB Karte vor ?

DEF FNmlreadstat%
LOCAL stat%,k%,i%

  i% = 0
  stat% = (inp(mladr%) and &H80) = &H80     ' Lesen des Status Registers
  WHILE (not stat%) and (i% < 10)
    i% = i% + 1
    for k% = -delaystat% to delaystat% : next k%
    stat% = (inp(mladr%) and &H80) = &H80   ' Lesen des Status Registers
  WEND
  FNmlreadstat% = stat%
END DEF

' Kann ein Datenbyte an die Multi-LAB Karte uebertragen werden ?

DEF FNmlwritestat%
LOCAL stat%,k%,i%

  i% = 0
  stat% = (inp(mladr%) and 1) <> 1        ' Lesen des Status Registers
  WHILE (not stat%) and (i% < 10)
    i% = i% + 1
    for k% = -delaystat% to delaystat% : next k%
    stat% = (inp(mladr%) and 1) <> 1       ' Lesen des Status Registers
  WEND
  FNmlwritestat% = stat%
END DEF

' Schreiben eines Datenbytes an die Multi-LAB Karte

SUB mlwrite(datbyte%)
SHARED mladr%,ferr%

  ferr% = 0
  IF FNmlwritestat% THEN                       ' Statusabfrage
    out mladr%+2, datbyte%                  ' Senden eines Datenbytes
  ELSE
    ferr% = 255
  END IF
END SUB

' Lesen eines Datenbytes von der Multi-LAB Karte

SUB mlread(datbyte%)
SHARED mladr%,ferr%

  ferr% = 0
  IF FNmlreadstat% THEN                        ' Statusabfrage
    datbyte% = inp(mladr%+1)                ' Lesen eines Datenbytes
  ELSE
    ferr% = 254
  END IF
END SUB

'************** Speicher und Konfigurationsbefehle *********************

' Synchronisierung der Multi-LAB Karte

SUB mlsync(zustand%)

  call mlwrite(0)                         ' SENDen einer 0
  call mlread(zustand%)                   ' Lesen eines Datenbytes

END SUB

' Reset der Multi-LAB Karte per Software

SUB mlreset(ferr1%)
SHARED mladr%

  out mladr%+3, 0               ' Datenbyte auf Resetadresse der
                                ' Multi-LAB Karte schreiben
  ferr1% = 0

END SUB

' Hardware-Reset-Blockierung der Multi-LAB Karte einschalten

SUB mlresblock(ferr1%)
SHARED ferr%

  call mlwrite(&H10)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB


' Hardware-Reset-Blockierung der Multi-LAB Karte ausschalten

SUB mlresunblock(ferr1%)
SHARED ferr%

  call mlwrite(&H11)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Groesse des vorhandenen RAM (Hardware)

SUB mlram(ferr1%,ramgroesse%)
LOCAL cmd%
SHARED ferr%

  ramgroesse% = 0                         ' Default = 0
  ferr1% = 0
  call mlwrite(&H12)                      ' Befehlscode senden
  call mlread(cmd%)                	  ' Datenbyte lesen
  IF cmd% = &H12 THEN              	  ' Datenbyte = Befehlscode ->
    call mlread(ramgroesse%)              ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Groesse des frei verfuegbaren RAM lesen (Software)

SUB mlvram(ferr1%,efram%,lfram%)
LOCAL dat1%,dat2%
SHARED ferr%

  efram% = 0 : lfram% = 0                 ' Default = 0
  ferr1% = 0
  call mlwrite(&H13)                      ' Befehlscode senden
  call mlread(dat1%)                      ' Datenbyte lesen
  IF dat1% = &H13 THEN                    ' Datenbyte = Befehlscode ->

    call mlread(dat1%)                    ' Datenbyte lesen
    call mlread(dat2%)                    ' Datenbyte lesen
    efram% = FNbyteint%(dat2%,dat1%)
    call mlread(dat1%)                    ' Datenbyte lesen
    call mlread(dat2%)                    ' Datenbyte lesen
    lfram% = FNbyteint%(dat2%,dat1%)
  ELSE
    ferr1% = dat1%                        ' sonst : Fehler
  END IF

END SUB

' Setzen des verfuegbaren RAM (Software)

SUB mlsram(ferr1%,mode%,adr%)
SHARED ferr%

  call mlwrite(&H14)                      ' Befehlscode senden
  call mlwrite(mode%)                     ' Datenbyte senden
  call mlwrite(adr% mod 256)              ' Datenbyte senden
  call mlwrite(int(adr% / 256))           ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Setzen der Konfiguration

SUB mlsetkonfig(ferr1%,config%)
SHARED ferr%

  call mlwrite(&H15)                      ' Befehlscode senden
  call mlwrite(config%)                   ' Konfiguration setzen
  ferr1% = ferr%

END SUB

'********************* Speicher und I/O-Befehle **************************

' Setzen des Memorypointers

SUB mlsetpoint(ferr1%,adr%)
SHARED ferr%

  call mlwrite(&H20)                      ' Befehlscode senden
  call mlwrite(adr% mod 256)              ' Datenbyte senden
  call mlwrite(int(adr% / 256))           ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Byte an Memorypointer schreiben

SUB mlsetdat(ferr1%,datbyte%)
SHARED ferr%

  call mlwrite(&H21)                      ' Befehlscode senden
  call mlwrite(datbyte%)                  ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Byte an Memorypointer schreiben und Pointer inkrementieren

SUB mlsetdati(ferr1%,datbyte%)
SHARED ferr%

  call mlwrite(&H22)                      ' Befehlscode senden
  call mlwrite(datbyte%)                  ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Datenbyte an einen I/O-Port ausgeben

SUB mloutport(ferr1%,portnr%,datbyte%)
SHARED ferr%

  call mlwrite(&H23)                  ' Befehlscode senden
  call mlwrite(portnr%)               ' Portadresse senden
  call mlwrite(datbyte%)              ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Programm ab Memorypointer starten

SUB mlstartpg(ferr1%)
SHARED ferr%

  call mlwrite(&H24)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Byte von Memorypointer lesen

SUB mlgetdat(ferr1%,datbyte%)
LOCAL cmd%
SHARED ferr%

  datbyte% = 0                 		  ' Default = 0
  ferr1% = 0
  call mlwrite(&H25)                      ' Befehlscode senden
  call mlread(cmd%)                   	  ' Datenbyte lesen
  IF cmd% = &H25 THEN                 	  ' Datenbyte = Befehlsbyte ->
    call mlread(datbyte%)                 ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Byte von Memorypointer lesen und Pointer inkrementieren

SUB mlgetdati(ferr1%,datbyte%)
LOCAL cmd%
SHARED ferr%

  datbyte% = 0                            ' Default = 0
  ferr1% = 0
  call mlwrite(&H26)                      ' Befehlscode senden
  call mlread(cmd%)                   	  ' Datenbyte lesen
  IF cmd% = &H26 THEN                 	  ' Datenbyte = Befehlscode ->
    call mlread(datbyte%)                 ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF
END SUB

' Lesen eines Datenbytes von einer I/O-Adresse

SUB mlinport(ferr1%,datbyte%,portnr%)
LOCAL cmd%
SHARED ferr%

  datbyte% = 0 			      ' Default = 0
  ferr1% = 0
  call mlwrite(&H27)                  ' Befehlscode senden
  call mlwrite(portnr%)               ' Portadresse senden
  call mlread(cmd%)                   ' Datenbyte lesen
  IF cmd% = &H27 THEN                 ' Datenbyte = Befehlscode ->
    call mlread(datbyte%)             ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                     ' sonst : Fehler
  END IF

END SUB

'***************************** LED *****************************************

' LED einschalten

SUB mlledon(ferr1%)
SHARED ferr%

  call mlwrite(&H30)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' LED ausschalten

SUB mlledoff(ferr1%)
SHARED ferr%

  call mlwrite(&H31)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Status der LED

SUB mlledstat(ferr1%,zustand%)
LOCAL cmd%
SHARED ferr%

  zustand% = 0                            ' Default = 0
  ferr1% = 0
  call mlwrite(&H33)                      ' Befehlscode senden
  call mlread(cmd%)                   	  ' Datenbyte lesen
  IF cmd% = &H33 THEN                 	  ' Datenbyte = Befehl
    call mlread(zustand%)                 ' Status lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

'********************* Drucker-Schnittstelle *******************************

' Byte an Drucker ausgeben

SUB mlprnwrite(ferr1%,datbyte$)
SHARED ferr%

  call mlwrite(&H36)                      ' Befehlscode senden
  call mlwrite(ASC(datbyte$))             ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Status der Druckerschnittstelle lesen

SUB mlprnstat(ferr1%,status%)
LOCAL cmd%
SHARED ferr%

  status% = 0                             ' Default = 0
  ferr1% = 0
  call mlwrite(&H3C)                      ' Befehlscode senden
  call mlread(cmd%)                    	  ' Datenbyte lesen
  IF cmd% = &H3C THEN                     ' Datenbyte = Befehlscode ->
    call mlread(status%)                  ' Status lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Status des Druckerbuffers lesen

SUB mlprnbufstat(ferr1%,status%)
LOCAL cmd%
SHARED ferr%

  status% = 0                             ' Default = 0
  ferr1% = 0
  call mlwrite(&H3D)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H3D THEN                     ' Datenbyte = Befehlscode ->
    call mlread(status%)                  ' Status lesen
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' Byte an Drucker ueber Buffer ausgeben

SUB mlprnbufwrite(ferr1%,datbyte$)
SHARED ferr%

  call mlwrite(&H37)                      ' Befehlscode senden
  call mlwrite(ASC(datbyte$))             ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Groesse des Druckerbuffers lesen

SUB mlgetbuf(ferr1%,status%)
LOCAL cmd%
SHARED ferr%

  status% = 0                             ' Default = 0
  ferr1% = 0
  call mlwrite(&H3E)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H3E THEN                     ' Datenbyte = Befehlscode ->
    call mlread(status%)                  ' Status lesen
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' Buffergroesse definieren

SUB mlsetbuf(ferr1%,datbyte%)
SHARED ferr%

  call mlwrite(&H38)                      ' Befehlscode senden
  call mlwrite(datbyte%)                  ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Ausgabe aus Buffer an Drucker unterbrechen

SUB mlprnbufstop(ferr1%)
SHARED ferr%

  call mlwrite(&H3A)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Ausgabe aus Buffer an Drucker fortsetzen

SUB mlprnbufstart(ferr1%)
SHARED ferr%

  call mlwrite(&H3B)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

'********************* Serielle Schnittstelle ******************************

' Serielle Schnittstelle initialisieren

SUB mlserialinit(ferr1%,Usart%,baud%,dum1%,dum2%)
SHARED ferr%

  call mlwrite(&H40)                      ' Befehlscode senden
  call mlwrite(usart%)                    ' Datenbyte senden
  call mlwrite(baud%)                     ' Datenbyte senden
  call mlwrite(dum1%)
  call mlwrite(dum2%)
  ferr1% = ferr%

END SUB

' Byte an Serielle Schnittstelle ausgeben

SUB mlserialwr(ferr1%,datbyte%)
SHARED ferr%

  call mlwrite(&H42)                      ' Befehlscode senden
  call mlwrite(datbyte%)                  ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Byte von Serieller Schnittstelle lesen

SUB mlserialre(ferr1%,datbyte%)
LOCAL cmd%
SHARED ferr%

  datbyte% = 0                            ' Default = 0
  ferr1% = 0
  call mlwrite(&H44)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H44 THEN                  	  ' Datenbyte = Befehlscode ->
    call mlread(datbyte%)                 ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Receiver-Status von Serieller Schnittstelle lesen

SUB mlserialrst(ferr1%,status%)
LOCAL cmd%
SHARED ferr%

  status% = 0                             ' Default = 0
  ferr1% = 0
  call mlwrite(&H45)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H45 THEN                     ' Datenbyte = Befehlscode ->
    call mlread(status%)                  ' Status lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Transmitter-Status von Serieller Schnittstelle lesen

SUB mlserialtst(ferr1%,status%)
LOCAL cmd%
SHARED ferr%

  status% = 0                             ' Default = 0
  ferr1% = 0
  call mlwrite(&H46)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H46 THEN                     ' Datenbyte = Befehlscode  ->
    call mlread(status%)                  ' Status lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Setze Sio-Flag

SUB mlserflagon(ferr1%)
SHARED ferr%

  call mlwrite(&H48)                      ' Befehlcode senden
  ferr1% = ferr%

END SUB


' Loesche Sio-Flag

SUB mlserflagoff(ferr1%)
SHARED ferr%

  call mlwrite(&H49)                      ' Befehlcode senden
  ferr1% = ferr%

END SUB

'************************ Digitale Eingnge *******************************

' Zustand aller digitalen Eingaenge lesen

SUB mldiginall(ferr1%,ip07%,ip815%,ip1623%)
LOCAL cmd%
SHARED ferr%

  ip07% = 0 : ip815% = 0 : ip1623% = 0    ' Default = 0
  ferr1% = 0
  call mlwrite(&H50)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H50 THEN                     ' Datenbyte = Befehlscode ->

      call mlread(ip07%)                  ' Zustaende lesen
      call mlread(ip815%)
      call mlread(ip1623%)
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' Zustand der digitalen Eingaenge IP0 - IP7 lesen

SUB mldigin1(ferr1%,ip07%)
LOCAL cmd%
SHARED ferr%

  ip07% = 0                               ' Default = 0
  ferr1% = 0
  call mlwrite(&H51)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H51 THEN                     ' Datenbyte = Befehlscode ->
    call mlread(ip07%)                    ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Zustand der digitalen Eingaenge IP8 - IP15 lesen

SUB mldigin2(ferr1%,ip815%)
LOCAL cmd%
SHARED ferr%

  ip815% = 0                              ' Default = 0
  ferr1% = 0
  call mlwrite(&H52)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H52 THEN                     ' Datenbyte = Befehlscode ->
    call mlread(ip815%)                   ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Zustand der digitalen Eingaenge IP16 - IP23 lesen

SUB mldigin3(ferr1%,ip1623%)
LOCAL cmd%
SHARED ferr%

  ip1623% = 0                             ' Default = 0
  ferr1% = 0
  call mlwrite(&H53)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H53 THEN                     ' Datenbyte = Befehlsbyte ->
    call mlread(ip1623%)                  ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst Fehler
  END IF

END SUB

' Zustand eines digitalen Eingangs lesen

SUB mldigbitin(ferr1%,zustand%,bit%)
LOCAL cmd%
SHARED ferr%

  zustand% = 0                            ' Default = 0
  ferr1% = 0
  call mlwrite(&H54)                      ' Befehlscode senden
  call mlwrite(bit% mod 24)               ' Datenbyte senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H54 THEN                     ' Datenbyte = Befehlscode ->
    call mlread(zustand%)                 ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

'************************* Digitale Ausgnge ******************************

' Alle digitalen Ausgaenge gleich 0 setzen

SUB mldigoutall0(ferr1%)
SHARED ferr%

  call mlwrite(&H58)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Alle digitalen Ausgaenge gleich 1 setzen

SUB mldigoutall1(ferr1%)
SHARED ferr%

  call mlwrite(&H59)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Alle digitalen Ausgaenge setzen

SUB mldigoutall(ferr1%,op07%,op815%,op1623%)
SHARED ferr%

  call mlwrite(&H5A)                      ' Befehlscode senden
  call mlwrite(op07%)                     ' Datenbyte senden
  call mlwrite(op815%)                    ' Datenbyte senden
  call mlwrite(op1623%)                   ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Die digitalen Ausgaenge OP0 - OP7 setzen

SUB mldigout1(ferr1%,op07%)
SHARED ferr%

  call mlwrite(&H5B)                      ' Befehlscode senden
  call mlwrite(op07%)                     ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Die digitalen Ausgaenge OP8 - OP15 setzen

SUB mldigout2(ferr1%,op815%)
SHARED ferr%

  call mlwrite(&H5C)                      ' Befehlscode senden
  call mlwrite(op815%)                    ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Die digitalen Ausgaenge OP16 - OP23 setzen

SUB mldigout3(ferr1%,op1623%)
SHARED ferr%

  call mlwrite(&H5D)                      ' Befehlscode senden
  call mlwrite(op1623%)                   ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Einen digitalen Ausgang gleich 0 setzen

SUB mldigbitout0(ferr1%,bit%)
SHARED ferr%

  call mlwrite(&H5E)                      ' Befehlscode senden
  call mlwrite(bit% mod 24)               ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Einen digitalen Ausgang gleich 1 setzen

SUB mldigbitout1(ferr1%,bit%)
SHARED ferr%

  call mlwrite(&H5F)                      ' Befehlscode senden
  call mlwrite(bit% mod 24)               ' Datenbyte senden
  ferr1% = ferr%

END SUB

'************************* 12 Bit D/A Wandler ******************************

' 12-Bit Wert an D/A-Kanal ausgeben

SUB mlda12out(ferr1%,kanal%,datbyte%)
SHARED ferr%

  IF kanal% = 1 THEN                       ' D/A-Kanal = 1 ->
    call mlwrite(&H60)                     ' Befehlscode senden
  ELSEIF kanal% = 2 THEN                   ' oder D/A-Kanal = 2 ->
    call mlwrite(&H61)                     ' Befehlscode senden
  END IF

  IF kanal% = 1 OR kanal% = 2 THEN         ' D/A-Kanal = 1 oder 2 ->
    call mlwrite(datbyte% mod 256)         ' Datenbyte (Low-Byte) senden
    call mlwrite(int(datbyte% / 256))      ' Datenbyte (High-Byte) senden
    ferr1% = ferr%
  ELSE
    ferr1% = 1                             ' sonst : Fehler
  END IF

END SUB

' Alle D/A-Wandler mit Aussteuerbereich 0 - 5 Volt

SUB mlda812out(ferr1%,kanal%,datbyte%)
SHARED ferr%

  call mlwrite(&H69)                      ' Befehlscode senden
  call mlwrite(kanal%)                    ' Kanalnummer senden
  call mlwrite(datbyte% mod 256)          ' Datenbyte (Low-Byte) senden
  call mlwrite(int(datbyte% / 256))       ' Datenbyte (High-Byte) senden
  ferr1% = ferr%

END SUB

' Abgleich der D/A-Wandler

SUB mldaabgleich(ferr1%)
SHARED ferr%

  call mlwrite(&H6B)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Beim Abgleich ermittelte Korrekturwerte ignorieren

SUB mldaignabgl(ferr1%)
SHARED ferr%

  call mlwrite(&H6C)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Pen up

SUB mlpenup(ferr1%)
SHARED ferr%

  call mlwrite(&H63)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB

' Pen down

SUB mlpendown(ferr1%)
SHARED ferr%

  call mlwrite(&H64)                      ' Befehlscode senden
  ferr1% = ferr%

END SUB


' Status von Pen

SUB mlpenstat(ferr1%,zustand%)
LOCAL cmd%
SHARED ferr%

  zustand% = 0                            ' Default = 0
  ferr1% = 0
  call mlwrite(&H6E)                      ' Befehlscode senden
  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &H6E THEN                     ' Datenbyte = Befehlscode ->
    call mlread(zustand%)                 ' Status lesen
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' 12-Bit Wert an D/A-Kanal ausgeben (2er Komplement)

SUB mlda122er(ferr1%,kanal%,datbyte%)
SHARED ferr%

  IF kanal% = 1 THEN                       ' D/A-Kanal = 1 ->
    call mlwrite(&H7A)                     ' Befehlscode senden
  ELSEIF kanal% = 2 THEN                   ' oder D/A-Kanal = 2 ->
    call mlwrite(&H7B)                     ' Befehlscode senden
  END IF
  IF kanal% = 1 OR kanal% = 2 THEN          ' D/A-Kanal = 1 oder 2 ->

    call mlwrite(datbyte% mod 256)         ' Datenbyte (Low-Byte) senden
    call mlwrite(int(datbyte% / 256))      ' Datenbyte (High-Byte) senden
    ferr1% = ferr%
  ELSE
    ferr1% = 1                             ' sonst : Fehler
  END IF

END SUB

' DA-X und DA-Y als Plotter : Positioniere auf X0/Y0

SUB mlposxy(ferr1%,X0%,Y0%)
SHARED ferr%

  call mlwrite(&H65)                      ' Befehlscode senden
  call mlwrite(X0% mod 256)               ' X0 (Low-Byte) senden
  call mlwrite(int(X0% / 256))            ' X0 (High-Byte) senden
  call mlwrite(Y0% mod 256)               ' Y0 (Low-Byte) senden
  call mlwrite(int(Y0% / 256))            ' Y0 (High-Byte) senden
  ferr1% = ferr%

END SUB

' DA-X und DA-Y als Plotter : Linie ziehen von X0/Y0 nach X1/Y1

SUB mllinxy(ferr1%,X1%,Y1%)
SHARED ferr%

  call mlwrite(&H66)                      ' Befehlscode senden
  call mlwrite(X1% mod 256)               ' X1 (Low-Byte) senden
  call mlwrite(int(X1% / 256))            ' X1 (High-Byte) senden
  call mlwrite(Y1% mod 256)               ' Y1 (Low-Byte) senden
  call mlwrite(int(Y1% / 256))            ' Y1 (High-Byte) senden
  ferr1% = ferr%

END SUB

' Korrekturflag setzen

SUB mlsetkorflag(ferr1%,flag%)
SHARED ferr%

  call mlwrite(&H7C)                       ' Befehlscode senden
  call mlwrite(flag%)                      ' Datenbyte senden
  ferr1% = ferr%

END SUB

' Korrekturwerte setzen

SUB mlsetkorwert(ferr1%,flag%,wert%)
SHARED ferr%

  call mlwrite(&H7D)                       ' Befehlscode senden
  call mlwrite(flag%)                      ' Datenbyte senden
  call mlwrite(wert% mod 256)              ' Datenwert (Low-Byte) senden
  call mlwrite(int(wert% / 256))           ' Datenwert (High-Byte) senden
  ferr1% = ferr%

END SUB

'*************************** 8 Bit D/A-Wandler *****************************

' 8-Bit Wert an D/A-Kanal ausgeben

SUB mlda8out(ferr1%,kanal%,datbyte%)
SHARED ferr%

  call mlwrite(&H70+(kanal% mod 16))       ' Befehlscode senden
  call mlwrite(datbyte%)                   ' Datenbyte senden
  ferr1% = ferr%

END SUB

'****************************** A/D-Wandler *******************************

' 12-Bit Wert von A/D-Kanal lesen

SUB mlad12in(ferr1%,datbyte%,kanal%)
LOCAL dat1%,dat2%
SHARED ferr%

  datbyte% = 0                               ' Default = 0
  call mlwrite(&H80+(kanal% mod 16))         ' Befehlscode senden
  call mlread(dat1%)                         ' Datenbyte lesen
  IF dat1% = (&H80+(kanal% mod 16)) THEN     ' Datenbyte = Befehlscode ->

    call mlread(dat1%)                       ' Datenbyte (Low-Byte) lesen
    call mlread(dat2%)                       ' Datenbyte (High-Byte) lesen
    datbyte% = FNbyteint%(dat2%,dat1%)
    ferr1% = ferr%
  ELSE
    ferr1% = dat1%                           ' sonst : Fehler
  END IF

END SUB

' 8-Bit Wert von A/D-Kanal lesen

SUB mlad8in(ferr1%,datbyte%,kanal%)
SHARED ferr%

  datbyte% = 0                               ' Default = 0
  ferr1% = 0
  call mlwrite(&H90+(kanal% mod 16))         ' Befehlscode senden
  call mlread(datbyte%)                      ' Datenbyte lesen

  IF datbyte% = (&H90+(kanal% mod 16)) THEN  ' Datenbyte = Befehlscode ->

    call mlread(datbyte%)                    ' Datenbyte lesen
  ELSE
    ferr1% = datbyte%                        ' sonst : Fehler
  END IF

END SUB

' 12 Bit-Wert von A/D-Kanal lesen und im 2er Komplement ausgeben

SUB mlad122er(ferr1%,datbyte%,kanal%)
LOCAL dat1%,dat2%
SHARED ferr%

  datbyte% = 0                            ' Default = 0
  call mlwrite(&H78)                      ' Befehlscode senden
  call mlwrite(kanal%)                    ' Kanalnummer senden
  call mlread(dat1%)                      ' Datenbyte lesen
  IF dat1% = &H78 THEN                    ' Datenbyte = Befehlscode ->

    call mlread(kanal%)                   ' Kanal lesen
    call mlread(dat1%)                    ' Datenbyte (Low-Byte) lesen
    call mlread(dat2%)                    ' Datenbyte (High-Byte) lesen
    datbyte% = FNbyteint%(dat2%,dat1%)
    ferr1% = ferr%
  ELSE
    ferr1% = dat1%                        ' sonst : Fehler
  END IF

END SUB


' 12-Bit Wert von A/D-Kanal lesen

SUB mladsh12(ferr1%,datbyte%(1),kanal%,anz%)
LOCAL dat1%,dat2%,i%
SHARED ferr%

  i% = 0                                    ' Default = 0
  DO  UNTIL (i% = anz%)
    i% = i% + 1
    datbyte%(i%) = 0
  LOOP
  call mlwrite(&H79)                        ' Befehlscode senden
  call mlwrite(kanal%)                      ' Kanalnummer senden
  call mlwrite(anz%)                        ' Anzahl der Kanaele senden
  call mlread(dat1%)                        ' Datenbyte lesen
  IF dat1% = &H79 THEN                      ' Datenbyte = Befehlscode ->

      i% = 0
      DO  UNTIL (i% = anz%) or (ferr% <> 0)
        i% = i% + 1
        call mlread(dat1%)                  ' Datenbyte (Low-Byte) lesen
        call mlread(dat2%)                  ' Datenbyte (High-Byte) lesen
        datbyte%(i%) = FNbyteint%(dat2%,dat1%)
      LOOP
      ferr1% = ferr%
  ELSE
    ferr1% = dat1%                          ' sonst : Fehler
  END IF

END SUB

' 12 Bit-Wert von A/D-Kanal lesen (20 mA Schnittstelle)

SUB mlad1220(ferr1%,datbyte%,kanal%)
LOCAL dat1%,dat2%
SHARED ferr%

  datbyte% = 0                            ' Default = 0
  call mlwrite(&H7E)                      ' Befehlscode senden
  call mlwrite(kanal%)                    ' Kanalnummer senden
  call mlread(dat1%)                      ' Datenbyte lesen
  IF dat1% = &H7E THEN                    ' Datenbyte = Befehlscode ->

    call mlread(dat1%)                    ' Datenbyte (Low-Byte) lesen
    call mlread(dat2%)                    ' Datenbyte (High-Byte) lesen
    datbyte% = FNbyteint%(dat2%,dat1%)
    ferr1% = ferr%
  ELSE
    ferr1% = dat1%                        ' sonst : Fehler
  END IF

END SUB

' 12 Bit-Wert von A/D-Kanal lesen (mit Subaveraging)

SUB mlad12sa(ferr1%,datbyte%,kanal%,anz%)
LOCAL dat1%,dat2%
SHARED ferr%

  datbyte% = 0                            ' Default = 0
  call mlwrite(&H7F)                      ' Befehlscode senden
  call mlwrite(kanal%)                    ' Kanalnummer senden
  call mlwrite(anz%)                      ' Anzahl der Mittelungen
  call mlread(dat1%)                      ' Datenbyte lesen
  IF dat1% = &H7F THEN                    ' Datenbyte = Befehlscode ->

    call mlread(dat1%)                    ' Datenbyte (Low-Byte) lesen
    call mlread(dat2%)                    ' Datenbyte (High-Byte) lesen
    datbyte% = FNbyteint%(dat2%,dat1%)
    ferr1% = ferr%
  ELSE
    ferr1% = dat1%                        ' sonst : Fehler
  END IF

END SUB

'********************************* Uhr *************************************

' Betriebsart Uhr setzen

SUB mlbartuhr(ferr1%,art%)
SHARED ferr%

  call mlwrite(&HE0)                      ' Befehlscode senden
  call mlwrite(art%)                      ' Datenbyte senden
  ferr1% = ferr%

  delay(0.06)

END SUB

' Status festlegen

SUB mlsetbart(ferr1%,maske%,wert%)
SHARED ferr%

  call mlwrite(&HE8)                      ' Befehlscode senden
  call mlwrite(maske%)                    ' Maske senden
  call mlwrite(wert%)                     ' Bits senden
  ferr1% = ferr%

  delay(0.06)

END SUB

' Uhrzeit setzen

SUB mlsetuhrzeit(ferr1%,sec%,min%,std%)
SHARED ferr%

  call mlwrite(&HE1)                      ' Befehlscode senden
  call mlwrite(sec%)                      ' Datenbyte senden
  call mlwrite(min%)                      ' Datenbyte senden
  call mlwrite(std%)                      ' Datenbyte senden
  ferr1% = ferr%

  delay(0.06)

END SUB

' Datum setzen

SUB mlsetuhrdatum(ferr1%,tag%,mon%,jahr%,wochentag%,woche%)
SHARED ferr%

  call mlwrite(&HEC)                      ' Befehlscode senden
  call mlwrite(tag%)                      ' Datenbyte senden
  call mlwrite(mon%)                      ' Datenbyte senden
  call mlwrite(jahr%)                     ' Datenbyte senden
  call mlwrite(wochentag%)                ' Datenbyte senden
  call mlwrite(woche%)                    ' Datenbyte senden
  ferr1% = ferr%

  delay(0.06)

END SUB

' Alarmzeitgeber setzen

SUB mlsetal(ferr1%,sec%,min%,std%,tag%)
SHARED ferr%

  call mlwrite(&HE2)                      ' Befehlscode senden
  call mlwrite(sec%)                      ' Datenbyte senden
  call mlwrite(min%)                      ' Datenbyte senden
  call mlwrite(std%)                      ' Datenbyte senden
  call mlwrite(tag%)                      ' Datenbyte senden
  ferr1% = ferr%

  delay(0.06)

END SUB

' Timer T setzen

SUB mlsettim(ferr1%,sec%,min%,std%)
SHARED ferr%

  call mlwrite(&HE3)                      ' Befehlscode senden
  call mlwrite(sec%)                      ' Datenbyte senden
  call mlwrite(min%)                      ' Datenbyte senden
  call mlwrite(std%)                      ' Datenbyte senden
  ferr1% = ferr%

  delay(0.06)

END SUB

' Uhrzeit lesen

SUB mlgetuhrzeit(ferr1%,sec%,min%,std%)
LOCAL cmd%
SHARED ferr%

  sec% = 0 : min% = 0 : std% = 0          ' Default = 0
  call mlwrite(&HE5)                      ' Befehlscode senden

  delay(0.06)

  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &HE5 THEN                     ' Datenbyte = Befehlscode ->

    call mlread(sec%)                     ' Datenbyte lesen
    call mlread(min%)                     ' Datenbyte lesen
    call mlread(std%)                     ' Datenbyte lesen
    ferr1% = ferr%
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' Datum lesen

SUB mlgetuhrdatum(ferr1%,tag%,mon%,jahr%,wochentag%,woche%)
LOCAL cmd%
SHARED ferr%

  tag% = 0 : mon% = 0 : jahr% = 0         ' Default = 0
  wochentag% = 0 : woche% = 0
  call mlwrite(&HED)                      ' Befehlscode senden

  delay(0.06)

  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &HED THEN                     ' Datenbyte = Befehlscode ->

    call mlread(tag%)                     ' Datenbyte lesen
    call mlread(mon%)                     ' Datenbyte lesen
    call mlread(jahr%)                    ' Datenbyte lesen
    call mlread(wochentag%)               ' Datenbyte lesen
    call mlread(woche%)                   ' Datenbyte lesen
    ferr1% = ferr%
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' Alarmzeitgeber lesen

SUB mlgetal(ferr1%,sec%,min%,std%,tag%)
LOCAL cmd%
SHARED ferr%

  sec% = 0 : min% = 0 : std% = 0          ' Default = 0
  tag% = 0
  call mlwrite(&HE6)                      ' Befehlscode senden

  delay(0.06)

  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &HE6 THEN                     ' Datenbyte = Befehlscode ->

    call mlread(sec%)                     ' Datenbyte lesen
    call mlread(min%)                     ' Datenbyte lesen
    call mlread(std%)                     ' Datenbyte lesen
    call mlread(tag%)                     ' Datenbyte lesen
    ferr1% = ferr%
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' Timer T lesen

SUB mlgettim(ferr1%,sec%,min%,std%)
LOCAL cmd%
SHARED ferr%

  sec% = 0 : min% = 0 : std% = 0          ' Default = 0
  call mlwrite(&HE7)                      ' Befehlscode senden

  delay(0.06)

  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &HE7 THEN                     ' Datenbyte = Befehlscode ->

    call mlread(sec%)                     ' Datenbyte lesen
    call mlread(min%)                     ' Datenbyte lesen
    call mlread(std%)                     ' Datenbyte lesen
    ferr1% = ferr%
  ELSE
    ferr1% = cmd%
  END IF

END SUB

' Betriebsart der Uhr lesen

SUB mlgetbart(ferr1%,zustand%)
LOCAL cmd%
SHARED ferr%

  zustand% = 0                            ' Default = 0
  call mlwrite(&HE4)                      ' Befehlscode senden

  delay(0.06)

  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &HE4 THEN                     ' Datenbyte = Befehlscode ->
    call mlread(zustand%)                 ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB

' Byte in nichtfluechtigen Speicher schreiben

SUB mlsetsp(ferr1%,speicher%,data1%)
SHARED ferr%

  call mlwrite(&HEE)                      ' Befehlscode senden
  call mlwrite(speicher% mod 15)          ' Datenbyte senden
  call mlwrite(data1%)                    ' Datenbyte senden
  ferr1% = ferr%

  delay(0.06)

END SUB

' Byte aus nichtfluechtigen Speicher lesen

SUB mlgetsp(ferr1%,datbyte%,speicher%)
LOCAL cmd%
SHARED ferr%

  datbyte% = 0                            ' Default = 0
  call mlwrite(&HEF)                      ' Befehlscode senden
  call mlwrite(speicher% mod 15)          ' Datenbyte senden		

  delay(0.06)

  call mlread(cmd%)                       ' Datenbyte lesen
  IF cmd% = &HEF THEN                     ' Datenbyte = Befehlscode ->
    call mlread(datbyte%)                 ' Datenbyte lesen
  ELSE
    ferr1% = cmd%                         ' sonst : Fehler
  END IF

END SUB
