/* Letzte Bearbeitung : 23.08.1989  07:30 */

/*

   C  -  B I B L I O T H E K   fr die Makrobefehle

     der Multi-LAB Karte von SORCUS COMPUTER GmbH

   Version 1E            (nderungen vorbehalten)

   Getestet mit Microsoft-C V.2.03

*/

int mladr,err;             /* Multi-LAB Basisadresse, Fehlercode */

#define TON '\007'         /* Fehler Ton   */
#define delaystat 2000     /* Delaycounter */

/* Fehler-Check und Fehlermeldungen */

error(err)
int err;
{
int ch;

  if (err > 0) {
    putch(TON);
    printf("\n\n***** Error *****\n\n");
  }
  switch(err) {
  case 0 :
           break;
  case 1 :
           printf("Befehl ist ungltig\n");
           break;
  case 2 :
           printf("Befehl ist unvollstndig bertragen\n");
           break;
  case 3 :
           printf("Fehler bei der Ausfhrung des Befehls\n");
           break;
  case 4 :
           printf("Befehl ist noch nicht implementiert\n");
           break;
  case 5 :
           printf("Befehl kann nicht ausgefhrt werden, weil die Hardware nicht vorhanden ist\n");
           break;
  case 6 :
           printf("Mit dem Befehl wurde eine Funktionseinheit angesprochen, die bereits fr eine\n");
           printf("andere Funktion benutzt wird. Befehl wurde deshalb nicht ausgefhrt\n");
           break;
  case 7 :
           printf("Die anfragende Schnittstelle ist nicht Host\n");
           break;
  case 8 :
           printf("Es ist kein Zeichen an der seriellen Schnittstelle empfangen worden\n");
           break;
  case 9 :
           printf("Die serielle Schnittstelle ist im Host-Mode\n");
           break;
  case 255 :
           printf("*** Fehler  : Multi-LAB/1 kann kein Byte empfangen  ***\n");
           printf("*** Ursache : Falsche Basisadresse eingestellt oder ***\n");
           printf("***           Delay zu klein                        ***\n");
           break;
  case 254 :
           printf("*** Fehler  : Multi-LAB/1 sendet kein Byte zurck   ***\n");
           printf("*** Ursache : Falsche Basisadresse eingestellt oder ***\n");
           printf("***           Delay zu klein                        ***\n");
           break;
  default :
           printf("***** Zurckgeliefertes Byte: %4x *****\n",err);
           break;
  }
  if (err > 0) {
  printf("\n***** Error *****\n\n");
  ch = 78;
  printf("Abbruch (J / N) [ N ] : ");
  ch = getch() & 0xdf;
  if (ch == 74) exit();
  }
}


/* Enthlt die Schnittstelle von der Multi-LAB Karte zum PC ein Byte ? */

mlreadst()
{
  int status,i;

  i = 0;
  do {
    i += 1;                                  /* Zaehler dekrementieren */
    status = ((inp(mladr) & 128) == 128);    /* Lesen des Status Registers */

  } while ((status == 0) && (i < delaystat));
  return(status);
}

/* Ist die Schnittstelle vom PC zur Multi-LAB Karte frei ? */

mlwrites()
{
  int status,i;

  i = 0;
  do {
    i += 1;                                  /* Zaehler dekrementieren */
    status = ((inp(mladr) & 1) != 1);        /* Lesen des Status Registers */
  } while ((status == 0) && (i < delaystat));
  return(status);
}

/* Schreiben eines Datenbytes an die Multi-LAB Karte */

mlwrite(datbyte)
int datbyte;
{
  int status;
  err = 0;
  status = mlwrites();                       /* Statusabfrage */
  if (status == 1) outp(mladr+2,datbyte);    /* Senden eines Datenbytes */
  else err = 255;
}

/* Lesen eines Datenbytes von der Multi-LAB Karte */

mlread(datbyte)
int *datbyte;
{
  int status;
  err = 0;
  status = mlreadst();                       /* Statusabfrage */
  if (status == 1) *datbyte = inp(mladr+1);  /* Lesen eines Datenbytes */
  else err = 254;
}

/****************** Speicher und Konfigurationsbefehle ***********************/

/* Synchronisierung der Multi-LAB Karte */

mlsync(zustand)
int *zustand;
{
  if (err == 0) mlwrite(0);                  /* Senden einer 0 */
  if (err == 0) mlread(zustand);             /* Lesen eines Datenbytes */
}

/* Reset der Multi-LAB Karte per Software */

mlreset(err1)
int *err1;
{
  outp(mladr+3,0);                           /* Datenbyte auf Resetadresse der */
                                             /* Multi-LAB Karte schreiben */
  *err1 = 0;
}

/* Hardware-Reset-Blockierung der Multi-LAB Karte einschalten */

mlresblo(err1)
int *err1;
{
  if (err == 0) mlwrite(0x10);               /* Befehlscode senden */
  *err1 = err;
}

/* Hardware-Reset-Blockierung der Multi-LAB Karte ausschalten */

mlresunb(err1)
int *err1;
{
  if (err == 0) mlwrite(0x11);               /* Befehlscode senden */
  *err1 = err;
}

/* Gre des vorhandenen RAM (Hardware) lesen */

mlram(err1,ramgroesse)
int *err1,*ramgroesse;
{
  int cmd;

  *ramgroesse = 0;                           /* Default = 0 */
  if (err == 0) mlwrite(0x12);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x12))           /* Datenbyte = Befehlscode -> */
    mlread(ramgroesse);                      /* Datenbyte lesen */
  *err1 = err;
}

/* Gre des frei verfgbaren RAM lesen (Software) */

mlvram(err1,efram,lfram)
int *err1,*efram,*lfram;
{
  int int1,int2;

  *efram = 0; *lfram = 0;                    /* Default = 0 */
  if (err == 0) mlwrite(0x13);               /* Befehlscode senden */
  if (err == 0) mlread(&int1);               /* Datenbyte lesen */
  if ((err == 0) && (int1 == 0x13)) {        /* Datenbyte = Befehlscode -> */
    mlread(&int1);                           /* Datenbyte lesen */
    if (err == 0) mlread(&int2);             /* Datenbyte lesen */
    *efram = int2 * 256 + int1;
    if (err == 0) mlread(&int1);             /* Datenbyte lesen */
    if (err == 0) mlread(&int2);             /* Datenbyte lesen */
    *lfram = int2 * 256 + int1;
  }
  *err1 = err;
}

/* Setzen des verfgbaren RAM (Software) */

mlsram(err1,mode,adr)
int *err1,mode;
unsigned int adr;
{
  if (err == 0) mlwrite(0x14);               /* Befehlscode senden */
  if (err == 0) mlwrite(mode);               /* Datenbyte senden */
  if (err == 0) mlwrite(adr % 256);          /* Datenbyte senden */
  if (err == 0) mlwrite(adr / 256);          /* Datenbyte senden */
  *err1 = err;
}

/* Definieren der Hardware-Konfiguration */

mlsetkon(err1,konfig)
int *err1,konfig;
{
  if (err == 0) mlwrite(0x15);               /* Befehlscode senden */
  if (err == 0) mlwrite(konfig);             /* Datenbyte senden */
  *err1 = err;
}

/********************* Speicher und I/O-Befehle ******************************/

/* Setzen des Memorypointers */

mlsetpoi(err1,adr)
int *err1;
unsigned int adr;
{
  if (err == 0) mlwrite(0x20);               /* Befehlscode senden */
  if (err == 0) mlwrite(adr % 256);          /* Datenbyte senden */
  if (err == 0) mlwrite(adr / 256);          /* Datenbyte senden */
  *err1 = err;
}

/* Byte an die Speicherstelle schreiben, auf die der Memorypointer zeigt */

mlstdat(err1,datbyte)
int *err1,datbyte;
{
  if (err == 0) mlwrite(0x21);               /* Befehlscode senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/* Byte an die Speicherstelle schreiben, auf die der Memorypointer zeigt,
   und Memorypointer inkrementieren */

mlstdati(err1,datbyte)
int *err1,datbyte;
{
  if (err == 0) mlwrite(0x22);               /* Befehlscode senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/* Datenbyte an eine I/O-Adresse schreiben */

mloutp(err1,portnr,datbyte)
int *err1,portnr,datbyte;
{
  if (err == 0) mlwrite(0x23);               /* Befehlscode senden */
  if (err == 0) mlwrite(portnr);             /* Portadresse senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/* Programm ab Speicherstelle starten, auf die der Memorypointer zeigt */

mlpgmrun(err1)
int *err1;
{
  if (err == 0) mlwrite(0x24);               /* Befehlscode senden */
  *err1 = err;
}

/* Byte von der Speicherstelle lesen, auf die der Memorypointer zeigt */

mlgtdat(err1,datbyte)
int *err1,*datbyte;
{
  int cmd;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x25);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x25))           /* Datenbyte = Befehlscode -> */
    mlread(datbyte);                         /* Datenbyte lesen */
  *err1 = err;
}

/* Byte von der Speicherstelle lesen, auf die der Memorypointer zeigt
   und Memorypointer inkrementieren */

mlgtdati(err1,datbyte)
int *err1,*datbyte;
{
  int cmd;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x26);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x26))           /* Datenbyte = Befehlscode -> */
    mlread(datbyte);                         /* Datenbyte lesen */
  *err1 = err;
}

/* Datenbyte von einer I/O-Adresse lesen */

mlinp(err1,datbyte,portnr)
int *err1,*datbyte,portnr;
{
  int cmd;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x27);               /* Befehlscode senden */
  if (err == 0) mlwrite(portnr);             /* Portadresse senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x27))           /* Datenbyte = Befehlscode -> */
    mlread(datbyte);                         /* Datenbyte lesen */
  *err1 = err;
}

/************************************ LED ************************************/

/* LED einschalten */

mlledon(err1)
int *err1;
{
  if (err == 0) mlwrite(0x30);               /* Befehlscode senden */
  *err1 = err;
}

/* LED ausschalten */

mlledoff(err1)
int *err1;
{
  if (err == 0) mlwrite(0x31);               /* Befehlscode senden */
  *err1 = err;
}

/* Status der LED */

mlledst(err1,zustand)
int *err1,*zustand;
{
  int cmd;

  *zustand = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x33);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x33))           /* Datenbyte = Befehlcode -> */
    mlread(zustand);                         /* Status lesen */
  *err1 = err;
}

/*************************** Drucker-Schnittstelle ***************************/

/* Byte an Drucker ausgeben */

mlprnwr(err1,datbyte)
int *err1,datbyte;
{
  if (err == 0) mlwrite(0x36);               /* Befehlscode senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/* Status der Druckerschnittstelle lesen */

mlprnst(err1,status)
int *err1,*status;
{
  int cmd;

  *status = 0;                               /* Default = 0 */
  if (err == 0) mlwrite(0x3C);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x3C))           /* Datenbyte = Befehlscode -> */
    mlread(status);                          /* Status lesen */
  *err1 = err;
}

/* Status des Druckerbuffers lesen */

mlbufst(err1,status)
int *err1,*status;
{
  int cmd;

  *status = 0;                               /* Default = 0 */
  if (err == 0) mlwrite(0x3D);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x3D))           /* Datenbyte = Befehlscode -> */
    mlread(status);                          /* Status lesen */
  *err1 = err;
}

/* Byte an Drucker ber Buffer ausgeben */

mlbufwr(err1,datbyte)
int *err1,datbyte;
{
  if (err == 0) mlwrite(0x37);               /* Befehlscode senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/* Gre des Druckerbuffers lesen */

mlbufget(err1,groesse)
int *err1,*groesse;
{
  int cmd;

  *groesse = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x3E);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x3E))           /* Datenbyte = Befehlscode -> */
    mlread(groesse);                         /* Gre lesen */
  *err1 = err;
}

/* Buffergre definieren */

mlbufset(err1,datbyte)
int *err1,datbyte;
{
  if (err == 0) mlwrite(0x38);               /* Befehlscode senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/* Ausgabe aus Buffer an Drucker unterbrechen */

mlbufstp(err1)
int *err1;
{
  if (err == 0) mlwrite(0x3A);               /* Befehlscode senden */
  *err1 = err;
}

/* Ausgabe aus Buffer an Drucker fortsetzen */

mlbufcon(err1)
int *err1;
{
  if (err == 0) mlwrite(0x3B);               /* Befehlscode senden */
  *err1 = err;
}

/*************************** Serielle Schnittstelle **************************/

/* Serielle Schnittstelle initialisieren */

mlinitse(err1,usart,baud,dum1,dum2)
int *err1,usart,baud,dum1,dum2;
{
  if (err == 0) mlwrite(0x40);               /* Befehlscode senden */
  if (err == 0) mlwrite(usart);              /* Datenbyte senden */
  if (err == 0) mlwrite(baud);               /* Datenbyte senden */
  if (err == 0) mlwrite(dum1);
  if (err == 0) mlwrite(dum2);
  *err1 = err;
}

/* Byte an Serielle Schnittstelle ausgeben */

mlwrser(err1,datbyte)
int *err1,datbyte;
{
  if (err == 0) mlwrite(0x42);               /* Befehlscode senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/* Byte von Serieller Schnittstelle lesen */

mlreser(err1,datbyte)
int *err1,*datbyte;
{
  int cmd;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x44);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x44))           /* Datenbyte = Befehlscode -> */
    mlread(datbyte);                         /* Datenbyte lesen */
  *err1 = err;
}

/* Receiver-Status von Serieller Schnittstelle lesen */

mlrstser(err1,status)
int *err1,*status;
{
  int cmd;

  *status = 0;                               /* Default = 0 */
  if (err == 0) mlwrite(0x45);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x45))           /* Datenbyte = Befehlscode -> */
    mlread(status);                          /* Status lesen */
  *err1 = err;
}

/* Transmitter-Status von Serieller Schnittstelle lesen */

mltstser(err1,status)
int *err1,*status;
{
  int cmd;

  *status = 0;                               /* Default = 0 */
  if (err == 0) mlwrite(0x46);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x46))           /* Datenbyte = Befehlscode  -> */
    mlread(status);                          /* Status lesen */
  *err1 = err;
}

/* Transmitter- und Receiver-Status von Serieller Schnittstelle lesen */

mlwrstse(err1,status)
int *err1,*status;
{
  int cmd;

  *status = 0;                               /* Default = 0 */
  if (err == 0) mlwrite(0x47);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x47))           /* Datenbyte = Befehlscode  -> */
    mlread(status);                          /* Status lesen */
  *err1 = err;
}

/* Flag fr Serielle Schnittstelle setzen */

mlserfon(err1)
int *err1;
{
  if (err == 0) mlwrite(0x48);               /* Befehlscode senden */
  *err1 = err;
}

/* Flag fr Serielle Schnittstelle lschen */

mlserfof(err1)
int *err1;
{
  if (err == 0) mlwrite(0x49);               /* Befehlscode senden */
  *err1 = err;
}

/***************************** Digitale Eingaenge ****************************/

/* Zustand aller digitalen Eingnge lesen */

mldigina(err1,ip07,ip815,ip1623)
int *err1,*ip07,*ip815,*ip1623;
{
  int cmd;

  *ip07 = 0;*ip815 = 0;*ip1623 = 0;          /* Default = 0 */
  if (err == 0) mlwrite(0x50);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if (cmd == 0x50) {                         /* Datenbyte = Befehlscode -> */
    if (err == 0) mlread(ip07);              /* Zustnde lesen */
    if (err == 0) mlread(ip815);
    if (err == 0) mlread(ip1623);
  }
  *err1 = err;
}

/* Zustand der digitalen Eingnge IP0 - IP7 lesen */

mldigin1(err1,ip07)
int *err1,*ip07;
{
  int cmd;

  *ip07 = 0;                                 /* Default = 0 */
  if (err == 0) mlwrite(0x51);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x51))           /* Datenbyte = Befehlscode -> */
    mlread(ip07);                            /* Datenbyte lesen */
  *err1 = err;
}

/* Zustand der digitalen Eingnge IP8 - IP15 lesen */

mldigin2(err1,ip815)
int *err1,*ip815;
{
  int cmd;

  *ip815 = 0;                                /* Default = 0 */
  if (err == 0) mlwrite(0x52);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x52))           /* Datenbyte = Befehlscode -> */
    mlread(ip815);                           /* Datenbyte lesen */
  *err1 = err;
}

/* Zustand der digitalen Eingnge IP16 - IP23 lesen */

mldigin3(err1,ip1623)
int *err1,*ip1623;
{
  int cmd;

  *ip1623 = 0;                               /* Default = 0 */
  if (err == 0) mlwrite(0x53);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x53))           /* Datenbyte = Befehlscode -> */
    mlread(ip1623);                          /* Datenbyte lesen */
  *err1 = err;
}

/* Zustand eines digitalen Eingangs lesen */

mldiginb(err1,zustand,bit)
int *err1,*zustand,bit;
{
  int cmd;

  *zustand = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x54);               /* Befehlscode senden */
  if (err == 0) mlwrite(bit % 24);           /* Datenbyte senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x54))           /* Datenbyte = Befehlscode -> */
    mlread(zustand);                         /* Datenbyte lesen */
  *err1 = err;
}

/*************************** Digitale Ausgaenge ******************************/

/* Alle digitalen Ausgnge gleich 0 setzen */

mldigoa0(err1)
int *err1;
{
  if (err == 0) mlwrite(0x58);               /* Befehlscode senden */
  *err1 = err;
}

/* Alle digitalen Ausgnge gleich 1 setzen */

mldigoa1(err1)
int *err1;
{
  if (err == 0) mlwrite(0x59);               /* Befehlscode senden */
  *err1 = err;
}

/* Alle digitalen Ausgnge setzen */

mldigoua(err1,op07,op815,op1623)
int *err1,op07,op815,op1623;
{
  if (err == 0) mlwrite(0x5A);               /* Befehlscode senden */
  if (err == 0) mlwrite(op07);               /* Datenbyte senden */
  if (err == 0) mlwrite(op815);              /* Datenbyte senden */
  if (err == 0) mlwrite(op1623);             /* Datenbyte senden */
  *err1 = err;
}

/* Die digitalen Ausgnge OP0 - OP7 setzen */

mldigou1(err1,op07)
int *err1,op07;
{
  if (err == 0) mlwrite(0x5B);               /* Befehlscode senden */
  if (err == 0) mlwrite(op07);               /* Datenbyte senden */
  *err1 = err;
}

/* Die digitalen Ausgnge OP8 - OP15 setzen */

mldigou2(err1,op815)
int *err1,op815;
{
  if (err == 0) mlwrite(0x5C);               /* Befehlscode senden */
  if (err == 0) mlwrite(op815);              /* Datenbyte senden */
  *err1 = err;
}

/* Die digitalen Ausgnge OP16 - OP23 setzen */

mldigou3(err1,op1623)
int *err1,op1623;
{
  if (err == 0) mlwrite(0x5D);               /* Befehlscode senden */
  if (err == 0) mlwrite(op1623);             /* Datenbyte senden */
  *err1 = err;
}

/* Einen digitalen Ausgang gleich 0 setzen */

mldigob0(err1,bit)
int *err1,bit;
{
  if (err == 0) mlwrite(0x5E);               /* Befehlscode senden */
  if (err == 0) mlwrite(bit % 24);           /* Datenbyte senden */
  *err1 = err;
}

/* Einen digitalen Ausgang gleich 1 setzen */

mldigob1(err1,bit)
int *err1,bit;
{
  if (err == 0) mlwrite(0x5F);               /* Befehlscode senden */
  if (err == 0) mlwrite(bit % 24);           /* Datenbyte senden */
  *err1 = err;
}

/*************************** 12 Bit D/A-Wandler ******************************/

/* 12-Bit Wert an D/A-Kanal ausgeben */

mlda12ou(err1,kanal,datbyte)
int *err1,kanal;
unsigned int datbyte;
{
  if ((err == 0) && (kanal == 1))            /* D/A-Kanal = 1 -> */
    mlwrite(0x60);                           /* Befehlscode senden */
  else
    if ((err == 0) && (kanal == 2))          /* oder D/A-Kanal = 2 -> */
      mlwrite(0x61);                         /* Befehlscode senden */
  if ((kanal == 1) || (kanal == 2)) {        /* D/A-Kanal = 1 oder 2 -> */
    if (err == 0) mlwrite(datbyte % 256);    /* Datenbyte (Low-Byte) senden */
    if (err == 0) mlwrite(datbyte / 256);    /* Datenbyte (High-Byte) senden */
    *err1 = err;
  }
  else
    *err1 = 1;                               /* sonst : Fehler */
}

/* 12-Bit Wert an D/A-Kanal ausgeben
   (es mssen 8 D/A-Wandler vorhanden sein) */

mlda812o(err1,kanal,datbyte)
int *err1,kanal;
unsigned int datbyte;
{
  if (err == 0) mlwrite(0x69);               /* Befehlscode senden */
  if (err == 0) mlwrite(kanal);              /* Kanal senden */
  if (err == 0) mlwrite(datbyte % 256);      /* Datenbyte (Low-Byte) senden */
  if (err == 0) mlwrite(datbyte / 256);      /* Datenbyte (High-Byte) senden */
  *err1 = err;
}

/* Abgleich der D/A-Wandler */

mldaabgl(err1)
int *err1;
{
  if (err == 0) mlwrite(0x6B);               /* Befehlscode senden */
  *err1 = err;
}

/* Beim Abgleich ermittelte Korrekturwerte ignorieren */

mldaign(err1)
int *err1;
{
  if (err == 0) mlwrite(0x6C);               /* Befehlscode senden */
  *err1 = err;
}

/* Pen up */

mlpenup(err1)
int *err1;
{
  if (err == 0) mlwrite(0x63);               /* Befehlscode senden */
  *err1 = err;
}

/* Pen down */

mlpendo(err1)
int *err1;
{
  if (err == 0) mlwrite(0x64);               /* Befehlscode senden */
  *err1 = err;
}

/* Status von Pen */

mlpenst(err1,zustand)
int *err1,*zustand;
{
  int cmd;

  *zustand = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x6E);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0x6E))           /* Datenbyte = Befehlscode -> */
    mlread(zustand);                         /* Status lesen */
  *err1 = err;
}

/* 12-Bit Wert an D/A-Kanal ausgeben (2er Komplement) */

mlda122(err1,kanal,datbyte)
int *err1,kanal;
unsigned int datbyte;
{
  if ((err == 0) && (kanal == 1))            /* D/A-Kanal = 1 -> */
    mlwrite(0x7A);                           /* Befehlscode senden */
  else
    if ((err == 0) && (kanal == 2))          /* oder D/A-Kanal = 2 -> */
      mlwrite(0x7B);                         /* Befehlscode senden */
  if ((kanal == 1) || (kanal == 2)) {        /* D/A-Kanal = 1 oder 2 -> */
    if (err == 0) mlwrite(datbyte % 256);    /* Datenbyte (Low-Byte) senden */
    if (err == 0) mlwrite(datbyte / 256);    /* Datenbyte (High-Byte) senden */
    *err1 = err;
  }
  else
    *err1 = 1;                               /* sonst : Fehler */
}

/* DA-X und DA-Y als Plotter : Positioniere auf X0/Y0 */

mlposxy(err1,X0,Y0)
int *err1;
unsigned int X0,Y0;
{
  if (err == 0) mlwrite(0x65);               /* Befehlscode senden */
  if (err == 0) mlwrite(X0 % 256);           /* X0 (Low-Byte) senden */
  if (err == 0) mlwrite(X0 / 256);           /* X0 (High-Byte) senden */
  if (err == 0) mlwrite(Y0 % 256);           /* Y0 (Low-Byte) senden */
  if (err == 0) mlwrite(Y0 / 256);           /* Y0 (High-Byte) senden */
  *err1 = err;
}

/* DA-X und DA-Y als Plotter : Linie ziehen von X0/Y0 nach X1/Y1 */

mllinxy(err1,X1,Y1)
int *err1;
unsigned int X1,Y1;
{
  if (err == 0) mlwrite(0x66);               /* Befehlscode senden */
  if (err == 0) mlwrite(X1 % 256);           /* X1 (Low-Byte) senden */
  if (err == 0) mlwrite(X1 / 256);           /* X1 (High-Byte) senden */
  if (err == 0) mlwrite(Y1 % 256);           /* Y1 (Low-Byte) senden */
  if (err == 0) mlwrite(Y1 / 256);           /* Y1 (High-Byte) senden */
  *err1 = err;
}

/* Korrekturflag setzen */

mlkorf(err1,flag)
int *err1,flag;
{
  if (err == 0) mlwrite(0x7C);               /* Befehlscode senden */
  if (err == 0) mlwrite(flag);               /* Datenbyte senden */
  *err1 = err;
}

/* Korrekturwerte setzen */

mlkorw(err1,flag,wert)
int *err1,flag;
unsigned int wert;
{
  if (err == 0) mlwrite(0x7D);               /* Befehlscode senden */
  if (err == 0) mlwrite(flag);               /* Datenbyte senden */
  if (err == 0) mlwrite(wert % 256);         /* Datenwert (Low-Byte) senden */
  if (err == 0) mlwrite(wert / 256);         /* Datenwert (High-Byte) senden */
  *err1 = err;
}

/************************** 8 Bit D/A-Wandler ********************************/

/* 8-Bit Wert an D/A-Kanal ausgeben */

mlda8out(err1,kanal,datbyte)
int *err1,kanal,datbyte;
{
  if (err == 0) mlwrite(0x70+(kanal % 16));  /* Befehlscode senden */
  if (err == 0) mlwrite(datbyte);            /* Datenbyte senden */
  *err1 = err;
}

/**************************** 12 Bit A/D-Wandler *****************************/

/* 12-Bit Wert von A/D-Kanal lesen */

mlad12in(err1,datbyte,kanal)
int *err1,*datbyte,kanal;
{
  int dat1,dat2;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x80+(kanal % 16));  /* Befehlscode senden */
  if (err == 0) mlread(&dat1);               /* Datenbyte lesen */
  if (dat1 == (0x80+(kanal % 16))) {         /* Datenbyte = Befehlscode -> */
    if (err == 0) mlread(&dat1);             /* Datenbyte (Low-Byte) lesen */
    if (err == 0) mlread(&dat2);             /* Datenbyte (High-Byte) lesen */
    *datbyte = dat2 * 256 + dat1;
  }
  *err1 = err;
}

/* 8-Bit Wert von A/D-Kanal lesen */

mlad8in(err1,datbyte,kanal)
int *err1,*datbyte,kanal;
{
  int cmd;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x90+(kanal % 16));  /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if (cmd == (0x90+(kanal % 16)))            /* Datenbyte = Befehlscode -> */
    if (err == 0) mlread(datbyte);           /* Datenbyte lesen */
  *err1 = err;                               /* sonst : Fehler */
}

/* 12 Bit-Wert von A/D-Kanal lesen und im 2er Komplement ausgeben */

mlad122(err1,datbyte,kanal)
int *err1,*datbyte,kanal;
{
  int dat1,dat2;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x78);               /* Befehlscode senden */
  if (err == 0) mlwrite(kanal);              /* Kanalnummer senden */
  if (err == 0) mlread(&dat1);               /* Datenbyte lesen */
  if ((err == 0) && (dat1 == 0x78)) {        /* Datenbyte = Befehlscode -> */
    if (err == 0) mlread(&dat1);             /* Kanal lesen */
    if (err == 0) mlread(&dat1);             /* Datenbyte (Low-Byte) lesen */
    if (err == 0) mlread(&dat2);             /* Datenbyte (High-Byte) lesen */
    *datbyte = dat2 * 256 + dat1;
  }
  *err1 = err;
}

/* 12-Bit Wert von A/D-Kanal lesen */

mladsh12(err1,datbyte,kanal,anz)
int *err1,kanal,anz,datbyte[];
{
  int dat1,dat2,i;

  i = 0;                                     /* Default = 0 */
  do {
    datbyte [i] = 0; i += 1;
  } while (i != anz);
  if (err == 0) mlwrite(0x79);               /* Befehlscode senden */
  if (err == 0) mlwrite(kanal);              /* Kanalnummer senden */
  if (err == 0) mlwrite(anz);                /* Anzahl der Kanle senden */
  if (err == 0) mlread(&dat1);               /* Datenbyte lesen */
  if (dat1 == 0x79) {                        /* Datenbyte = Befehlscode -> */
    i = 0;
    do {
      if (err == 0) mlread(&dat1);           /* Datenbyte (Low-Byte) lesen */
      if (err == 0) mlread(&dat2);           /* Datenbyte (High-Byte) lesen */
      datbyte [i] = dat2 * 256 + dat1;
      i += 1;
    } while ((i != anz) && (err == 0) && (i != 64));
  }
  *err1 = err;
}

/* 12-Bit Wert von A/D-Kanal lesen (20 mA-Schnittstelle) */

mlad1220(err1,datbyte,kanal)
int *err1,*datbyte,kanal;
{
  int dat1,dat2;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x7E);               /* Befehlscode senden */
  if (err == 0) mlwrite(kanal);              /* Kanalnummer senden */
  if (err == 0) mlread(&dat1);               /* Datenbyte lesen */
  if (dat1 == (0x7E)) {                      /* Datenbyte = Befehlscode -> */
    if (err == 0) mlread(&dat1);             /* Datenbyte (Low-Byte) lesen */
    if (err == 0) mlread(&dat2);             /* Datenbyte (High-Byte) lesen */
    *datbyte = dat2 * 256 + dat1;
  }
  *err1 = err;
}

/* 12-Bit Wert von A/D-Kanal lesen mit Sub-Averaging */

mlad12sa(err1,datbyte,kanal,anz)
int *err1,*datbyte,kanal,anz;
{
  int dat1,dat2;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0x7F);               /* Befehlscode senden */
  if (err == 0) mlwrite(kanal);              /* Kanalnummer senden */
  if (err == 0) mlwrite(anz);                /* Anzahl der Mittelungen senden */
  if (err == 0) mlread(&dat1);               /* Datenbyte lesen */
  if (dat1 == (0x7F)) {                      /* Datenbyte = Befehlscode -> */
    if (err == 0) mlread(&dat1);             /* Datenbyte (Low-Byte) lesen */
    if (err == 0) mlread(&dat2);             /* Datenbyte (High-Byte) lesen */
    *datbyte = dat2 * 256 + dat1;
  }
  *err1 = err;
}

/* Betriebsart Uhr setzen */

mlbarts(err1,art)
int *err1,art;
{
  if (err == 0) mlwrite(0xE0);               /* Befehlscode senden */
  if (err == 0) mlwrite(art);                /* Datenbyte senden */
  *err1 = err;
}

/* Uhrzeit setzen */

mlzeits(err1,sec,min,std)
int *err1,sec,min,std;
{
  if (err == 0) mlwrite(0xE1);               /* Befehlscode senden */
  if (err == 0) mlwrite(sec);                /* Datenbyte senden */
  if (err == 0) mlwrite(min);                /* Datenbyte senden */
  if (err == 0) mlwrite(std);                /* Datenbyte senden */
  *err1 = err;
}

/* Datum setzen */

mldatums(err1,tag,mon,jahr,wochentag,woche)
int *err1,tag,mon,jahr,wochentag,woche;
{
  if (err == 0) mlwrite(0xEC);               /* Befehlscode senden */
  if (err == 0) mlwrite(tag);                /* Datenbyte senden */
  if (err == 0) mlwrite(mon);                /* Datenbyte senden */
  if (err == 0) mlwrite(jahr);               /* Datenbyte senden */
  if (err == 0) mlwrite(wochentag);          /* Datenbyte senden */
  if (err == 0) mlwrite(woche);              /* Datenbyte senden */
  *err1 = err;
}

/* Alarmzeitgeber setzen */

mlalarms(err1,sec,min,std,tag)
int *err1,sec,min,std,tag;
{
  if (err == 0) mlwrite(0xE2);               /* Befehlscode senden */
  if (err == 0) mlwrite(sec);                /* Datenbyte senden */
  if (err == 0) mlwrite(min);                /* Datenbyte senden */
  if (err == 0) mlwrite(std);                /* Datenbyte senden */
  if (err == 0) mlwrite(tag);                /* Datenbyte senden */
  *err1 = err;
}

/* Timer T setzen */

mltimers(err1,sec,min,std)
int *err1,sec,min,std;
{
  if (err == 0) mlwrite(0xE3);               /* Befehlscode senden */
  if (err == 0) mlwrite(sec);                /* Datenbyte senden */
  if (err == 0) mlwrite(min);                /* Datenbyte senden */
  if (err == 0) mlwrite(std);                /* Datenbyte senden */
  *err1 = err;
}

/* Uhrzeit lesen */

mlzeitg(err1,sec,min,std)
int *err1,*sec,*min,*std;
{
  int cmd;

  *sec = 0; *min = 0; *std = 0;              /* Default = 0 */
  if (err == 0) mlwrite(0xE5);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xE5)) {         /* Datenbyte = Befehlscode -> */
    mlread(sec);                             /* Datenbyte lesen */
    if (err == 0) mlread(min);               /* Datenbyte lesen */
    if (err == 0) mlread(std);               /* Datenbyte lesen */
  }
  *err1 = err;
}

/* Datum lesen */

mldatumg(err1,tag,mon,jahr,wtag,woche)
int *err1,*tag,*mon,*jahr,*wtag,*woche;
{
  int cmd;

  *tag = 0; *mon = 0; *jahr = 0;             /* Default = 0 */
  *wtag = 0; *woche = 0;
  if (err == 0) mlwrite(0xED);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xED)) {         /* Datenbyte = Befehlscode -> */
    mlread(tag);                             /* Datenbyte lesen */
    if (err == 0) mlread(mon);               /* Datenbyte lesen */
    if (err == 0) mlread(jahr);              /* Datenbyte lesen */
    if (err == 0) mlread(wtag);              /* Datenbyte lesen */
    if (err == 0) mlread(woche);             /* Datenbyte lesen */
  }
  *err1 = err;
}

/* Alarmzeitgeber lesen */

mlalarmg(err1,sec,min,std,tag)
int *err1,*sec,*min,*std,*tag;
{
  int cmd;

  *sec = 0; *min = 0; *std = 0;              /* Default = 0 */
  *tag = 0;
  if (err == 0) mlwrite(0xE6);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xE6)) {         /* Datenbyte = Befehlscode -> */
    mlread(sec);                             /* Datenbyte lesen */
    if (err == 0) mlread(min);               /* Datenbyte lesen */
    if (err == 0) mlread(std);               /* Datenbyte lesen */
    if (err == 0) mlread(tag);               /* Datenbyte lesen */
  }
  *err1 = err;
}

/* Timer T lesen */

mltimerg(err1,sec,min,std)
int *err1,*sec,*min,*std;
{
  int cmd;

  *sec = 0; *min = 0; *std = 0;              /* Default = 0 */
  if (err == 0) mlwrite(0xE7);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xE7)) {         /* Datenbyte = Befehlscode -> */
    mlread(sec);                             /* Datenbyte lesen */
    if (err == 0) mlread(min);               /* Datenbyte lesen */
    if (err == 0) mlread(std);               /* Datenbyte lesen */
  }
  *err1 = err;
}

/* Status der Uhr setzen */

mlsbart(err1,maske,wert)
int *err1,maske,wert;
{
  if (err == 0) mlwrite(0x2D);               /* Befehlscode senden */
  if (err == 0) mlwrite(maske);              /* Datenbyte senden */
  if (err == 0) mlwrite(wert);               /* Datenbyte senden */
  *err1 = err;
}

/* Byte in nichtflchtigen Speicher schreiben */

mlsetsp(err1,speicher,data)
int *err1,speicher,data;
{
  if (err == 0) mlwrite(0xEE);               /* Befehlscode senden */
  if (err == 0) mlwrite(speicher % 15);      /* Datenbyte senden */
  if (err == 0) mlwrite(data);               /* Datenbyte senden */
  *err1 = err;
}


/* Byte aus nichtflchtigen Speicher lesen */

mlgetsp(err1,datbyte,speicher)
int *err1,*datbyte,speicher;
{
  int cmd;

  *datbyte = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0xEF);               /* Befehlscode senden */
  if (err == 0) mlwrite(speicher % 15);      /* Datenbyte senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xEF))           /* Datenbyte = Befehlscode -> */
    mlread(datbyte);                         /* Datenbyte lesen */
  *err1 = err;
}

/* Betriebsart der Uhr lesen */

mlbartg(err1,zustand)
int *err1,*zustand;
{
  int cmd;

  *zustand = 0;                              /* Default = 0 */
  if (err == 0) mlwrite(0xE4);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xE4))           /* Datenbyte = Befehlscode -> */
    mlread(zustand);                         /* Datenbyte lesen */
  *err1 = err;
}



/****************************************************************************/
/*                                                                          */
/*                     Multi-Tasking Befehle                                */
/*                                                                          */
/****************************************************************************/


/* Bibliothek fr die Taskbefehle der Multi-LAB Karte */

/* Installieren einer Task im ROM */

mlinstro(err1,tasknr,pgmnr,daten)
int *err1,tasknr,pgmnr;
unsigned int daten;
{
  if (err == 0) mlwrite(0xC0);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(pgmnr);              /* Programmnummer senden */
  if (err == 0) mlwrite(0);                  /* Dummy senden */
  if (err == 0) mlwrite(daten % 256);        /* Gre Datenbereich (Low) senden */
  if (err == 0) mlwrite(daten / 256);        /* Gre Datenbereich (High) senden */
  *err1 = err;
}

/* Installieren einer Task im RAM */

mlinstra(err1,tasknr,adr,daten)
int *err1,tasknr;
unsigned int adr,daten;
{
  if (err == 0) mlwrite(0xC0);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(adr % 256);          /* RAM-Adresse (Low) senden */
  if (err == 0) mlwrite(adr / 256);          /* RAM-Adresse (High) senden */
  if (err == 0) mlwrite(daten % 256);        /* Gre Datenbereich (Low) senden */
  if (err == 0) mlwrite(daten / 256);        /* Gre Datenbereich (High) senden */
  *err1 = err;
}

/* Verbinden zweier Tasks */

mlverbin(err1,tasknr1,tasknr2)
int *err1,tasknr1,tasknr2;
{
  if (err == 0) mlwrite(0xC1);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr1);            /* Tasknummer 1 senden */
  if (err == 0) mlwrite(tasknr2);            /* Tasknummer 2 senden */
  *err1 = err;
}

/* Lschen einer Task */

mlloesch(err1,tasknr)
int *err1,tasknr;
{
  if (err == 0) mlwrite(0xC2);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  *err1 = err;
}

/* Melde Programmnummer, wenn Programm vorhanden */

mlpgmvor(err1,pgmnr)
int *err1,pgmnr;
{
  int vorhanden,cmd;

  vorhanden = 0;                             /* Default = 0 */
  if (err == 0) mlwrite(0xC3);               /* Befehlscode senden */
  if (err == 0) mlwrite(pgmnr);              /* Programmnummer senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xC3))           /* Datenbyte = Befehlscode -> */
    mlread(&vorhanden);                      /* Datenbyte lesen */
  *err1 = err;
  return(vorhanden);                         /* Datenbyte bergeben */
}

/* Melden der Nummer eines Programms, das unter der angegebenen Task installiert ist */

mlmeldep(err1,tasknr)
int *err1,tasknr;
{
  int melde,cmd,dat;

  melde = 0;                                 /* Default = 0 */
  if (err == 0) mlwrite(0xC4);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xC4)) {         /* Datenbyte = Befehlscode -> */
    mlread(&dat);                            /* Tasknummer lesen */
    if (err == 0) mlread(&melde);            /* Programmnummmer lesen */
    }
  *err1 = err;
  return(melde);                             /* Programmnummer bergeben */
}

/* Starten einer Prozedur einer Task */

mlrunpro(err1,tasknr,proc)
int *err1,tasknr,proc;
{
  if (err == 0) mlwrite(0xC5);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer ssenden */
  if (err == 0) mlwrite(proc);               /* Nummer der Prozedur senden */
  *err1 = err;
}

/* Pointer fr Datenbereich setzen */

mltsetda(err1,tasknr,adr)
int *err1,tasknr;
unsigned int adr;
{
  if (adr == 0) {
    if (err == 0) mlwrite(0xC6);             /* Befehlscode senden */
    if (err == 0) mlwrite(tasknr);           /* Tasknummer senden */
    }
  else {
    if (err == 0) mlwrite(0xC7);             /* Befehlscode senden */
    if (err == 0) mlwrite(tasknr);           /* Tasknummer senden */
    if (err == 0) mlwrite(adr % 256);        /* Adresse (Low) senden */
    if (err == 0) mlwrite(adr / 256);        /* Adresse (High) senden */
    }
  *err1 = err;
}

/* Datenbyte einer Task lesen */

mlgetbyt(err1,tasknr)
int *err1,tasknr;
{
  int dat,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xC8);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xC8)) {         /* Datenbyte = Befehlscode -> */
    mlread(&dat);                            /* Tasknummer lesen */
    if (err == 0) mlread(&dat);              /* Datenbyte lesen */
    }
  *err1 = err;
  return(dat);                               /* Datenbyte bergeben */
}

/* Datenbyte einer Task setzen */

mlsetbyt(err1,tasknr,dat)
int *err1,tasknr,dat;
{
  if (err == 0) mlwrite(0xC9);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(dat);                /* Datenbyte senden */
  *err1 = err;
}

/* Datenwort einer Task lesen */

mlgetint(err1,tasknr)
int *err1,tasknr;
{
  int dat,int1,int2,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xCA);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0 ) && (cmd == 0xCA)) {        /* Datenbyte = Befehlscode -> */
    mlread(&dat);                            /* Tasknummer lesen */
    if (err == 0) mlread(&int1);             /* Datenwort (Low) lesen */
    if (err == 0) mlread(&int2);             /* Datenwort (High) lesen */
    dat = int2 * 256 + int1;
    }
  *err1 = err;
  return(dat);                               /* Datenwort bergeben */
}

/* Datenwort einer Task setzen */

mlsetint(err1,tasknr,dat)
int *err1,tasknr;
unsigned int dat;
{
  if (err == 0) mlwrite(0xCB);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(dat % 256);          /* Datenwort (Low) senden */
  if (err == 0) mlwrite(dat / 256);          /* Datenwort (High) senden */
  *err1 = err;
}

/* Block von Daten lesen */

mltblre(err1,tasknr,zahl,daten)
int *err1,tasknr,daten[];
unsigned int zahl;
{
  unsigned int i;
  int cmd,dat1,dat2;

  if (err == 0) mlwrite(0xD0);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(zahl % 256);         /* Anzahl (Low) senden */
  if (err == 0) mlwrite(zahl / 256);         /* Anzahl (High) senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xD0)) {         /* Datenbyte = Befehlscode -> */
    mlread(&dat1);                           /* Tasknummer lesen */
    if ((dat1 == tasknr) && (err == 0)) {
      i = 0;
      while ((err == 0) && (i < (zahl / 2))) {
        mlread(&dat1);                       /* Daten lesen */
        if (err == 0) mlread(&dat2);         /* Daten lesen */
        daten[i] = dat2 * 256 + dat1;
        i += 1;
      }
    }
  }
  *err1 = err;
}

/* Block von Daten schreiben */

mltblwr(err1,tasknr,zahl,daten)
int *err1,tasknr,daten[];
unsigned int zahl;
{
  unsigned int i;
  int bite;

  if (err == 0) mlwrite(0xD1);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(i % 256);            /* Anzahl (Low) senden */
  if (err == 0) mlwrite(i / 256);            /* Anzahl (High) senden */
  i = 0;
  while ((err == 0) && (i < (zahl / 2))) {
    bite = daten[i] % 256;
    mlwrite(bite);                           /* Daten senden */
    bite = daten[i] / 256;
    if (err == 0) mlwrite(bite);             /* Daten senden */
    i += 1;
    }
  *err1 = err;
}

/* Parameter (Byte) einer Task lesen */

mlbgetpa(err1,tasknr,parnr)
int *err1,tasknr,parnr;
{
  int dat,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xCC);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xCC)) {         /* Datenbyte = Befehlscode -> */
    mlread(&dat);                            /* Tasknummer lesen */
    if (err == 0) mlread(&dat);              /* Parameterwert lesen */
    }
  *err1 = err;
  return(dat);                               /* Parameterwert bergeben */
}

/* Parameter (Byte) einer Task setzen */

mlbsetpa(err1,tasknr,parnr,parameter)
int *err1,tasknr,parnr,parameter;
{
  if (err == 0) mlwrite(0xCD);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlwrite(parameter);          /* Parameterwert senden */
  *err1 = err;
}

/* Parameter (Wort) einer Task lesen */

mlwgetpa(err1,tasknr,parnr)
int *err1,tasknr,parnr;
{
  int dat,int1,int2,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xCE);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xCE)) {         /* Datenbyte = Befehlscode -> */
    mlread(&dat);                            /* Tasknummer lesen */
    if (err == 0) mlread(&int1);             /* Parameterwert (Low) lesen */
    if (err == 0) mlread(&int2);             /* Parameterwert (High) lesen */
    if (err == 0) dat = int2 * 256 + int1;
    }
  *err1 = err;
  return(dat);                               /* Parameterwert bergeben */
}

/* Parameter (Wort) einer Task setzen */

mlwsetpa(err1,tasknr,parnr,parameter)
int *err1,tasknr,parnr;
unsigned int parameter;
{
  if (err == 0) mlwrite(0xCF);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlwrite(parameter % 256);    /* Parameterwert (Low) senden */
  if (err == 0) mlwrite(parameter / 256);    /* Parameterwert (High) senden */
  *err1 = err;
}

/* Zugriff auf Daten und Parameter mit Vorwahl der Task-Nr. */

/* Anwahl einer Task */

mlwaehle(err1,tasknr)
int *err1,tasknr;
{
  if (err == 0) mlwrite(0xD4);               /* Befehlscode senden */
  if (err == 0) mlwrite(tasknr);             /* Tasknummer senden */
  *err1 = err;
}

/* Starten einer Prozedur einer Task */

mldrunpr(err1,proc)
int *err1,proc;
{
  if (err == 0) mlwrite(0xD5);               /* Befehlscode senden */
  if (err == 0) mlwrite(proc);               /* Nummer der Prozedur senden */
  *err1 = err;
}

/* Pointer fr Datenbereich setzen */

mldtsetd(err1,adr)
int *err1;
unsigned int adr;
{
  if (adr == 0) {
    if (err == 0) mlwrite(0xD6);             /* Befehlscode senden */
    }
  else {
    if (err == 0) mlwrite(0xD7);             /* Befehlscode senden */
    if (err == 0) mlwrite(adr % 256);        /* Adresse (Low) senden */
    if (err == 0) mlwrite(adr / 256);        /* Adresse (High) senden */
    }
  *err1 = err;
}

/* Datenbyte einer Task lesen */

mldgetby(err1)
int *err1;
{
  int dat,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xD8);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xD8)) {         /* Datenbyte = Befehlscode -> */
    mlread(&dat);                            /* Datenbyte lesen */
    }
  *err1 = err;
  return(dat);                               /* Datenbyte bergeben */
}

/* Datenbyte einer Task setzen */

mldsetby(err1,dat)
int *err1,dat;
{
  if (err == 0) mlwrite(0xD9);               /* Befehlscode senden */
  if (err == 0) mlwrite(dat);                /* Datenbyte senden */
  *err1 = err;
}

/* Datenwort einer Task lesen */

mldgetin(err1)
int *err1;
{
  int dat,int1,int2,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xDA);               /* Befehlscode senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0 ) && (cmd == 0xDA)) {        /* Datenbyte = Befehlscode -> */
    mlread(&int1);                           /* Datenwort (Low) lesen */
    if (err == 0) mlread(&int2);             /* Datenwort (High) lesen */
    dat = int2 * 256 + int1;
    }
  *err1 = err;
  return(dat);                               /* Datenwort bergeben */
}

/* Datenwort einer Task setzen */

mldsetin(err1,dat)
int *err1;
unsigned int dat;
{
  if (err == 0) mlwrite(0xDB);               /* Befehlscode senden */
  if (err == 0) mlwrite(dat % 256);          /* Datenwort (Low) senden */
  if (err == 0) mlwrite(dat / 256);          /* Datenwort (High) senden */
  *err1 = err;
}

/* Parameter (Byte) einer Task lesen */

mldbgetp(err1,parnr)
int *err1,parnr;
{
  int dat,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xDC);               /* Befehlscode senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xDC)) {         /* Datenbyte = Befehlscode -> */
    mlread(&dat);                            /* Parameterwert lesen */
    }
  *err1 = err;
  return(dat);                               /* Parameterwert bergeben */
}

/* Parameter (Byte) einer Task setzen */

mldbsetp(err1,parnr,parameter)
int *err1,parnr,parameter;
{
  if (err == 0) mlwrite(0xDD);               /* Befehlscode senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlwrite(parameter);          /* Parameterwert senden */
  *err1 = err;
}

/* Parameter (Wort) einer Task lesen */

mldwgetp(err1,parnr)
int *err1,parnr;
{
  int dat,int1,int2,cmd;

  dat = 0;                                   /* Default = 0 */
  if (err == 0) mlwrite(0xDE);               /* Befehlscode senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlread(&cmd);                /* Datenbyte lesen */
  if ((err == 0) && (cmd == 0xDE)) {         /* Datenbyte = Befehlscode -> */
    mlread(&int1);                           /* Parameterwert (Low) lesen */
    if (err == 0) mlread(&int2);             /* Parameterwert (High) lesen */
    if (err == 0) dat = int2 * 256 + int1;
    }
  *err1 = err;
  return(dat);                               /* Parameterwert bergeben */
}

/* Parameter (Wort) einer Task setzen */

mldwsetp(err1,parnr,parameter)
int *err1,parnr;
unsigned int parameter;
{
  if (err == 0) mlwrite(0xDF);               /* Befehlscode senden */
  if (err == 0) mlwrite(parnr);              /* rel. Adresse Parameter senden */
  if (err == 0) mlwrite(parameter % 256);    /* Parameterwert (Low) senden */
  if (err == 0) mlwrite(parameter / 256);    /* Parameterwert (High) senden */
  *err1 = err;
}




