' Multi-Tasking Befehle

' Version 1B        Letzte Bearbeitung : 23.08.1989  11:40

' Turbo-BASIC Bibliothek fuer die Taskbefehle der Multi-LAB Karte

' Einschrnkungen siehe MLABLIB.BAS !

' Installieren einer Task im ROM

SUB mlinsttask(ferr1%,tasknr%,pgmnr%,daten%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HC0)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(pgmnr%)             ' Programmnummer
  IF ferr% = 0 then call mlwrite(0)                  ' Dummy
  IF ferr% = 0 then call mlwrite(daten% mod 256)     ' Groesse Datenbereich (Low)
  IF ferr% = 0 then call mlwrite(int(daten% / 256))  ' Groesse Datenbereich (High)
  ferr1% = ferr%

END SUB

' Installieren einer Task im RAM

SUB mlinstramtask(ferr1%,tasknr%,adr%,daten%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HC0)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)	     ' Tasknummer
  IF ferr% = 0 then call mlwrite(adr% mod 256)       ' RAM-Adresse (Low)
  IF ferr% = 0 then call mlwrite(int(adr% / 256))    ' RAM-Adresse (High)
  IF ferr% = 0 then call mlwrite(daten% mod 256)     ' Groesse Datenbereich (Low)
  IF ferr% = 0 then call mlwrite(int(daten% / 256))  ' Groesse Datenbereich (High)
  ferr1% = ferr%

END SUB

' Verbinden zweier Tasks

SUB mlverbindetask(ferr1%,tasknr1%,tasknr2%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HC1)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr1%)           ' Tasknummer
  IF ferr% = 0 then call mlwrite(tasknr2%)           ' Tasknummer
  ferr1% = ferr%

END SUB

' Loeschen einer Task

SUB mlloeschetask(ferr1%,tasknr%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HC2)
  IF ferr% = 0 then call mlwrite(tasknr%)
  ferr1% = ferr%

END SUB

' Melde Programmnummer, wenn Programm vorhanden

DEF FNmlpgmvorhanden%(ferr1%,pgmnr%)
LOCAL dat%,cmd%
SHARED ferr%

  dat% = 0                                         ' Default = 0
  IF ferr% = 0 then call mlwrite(&HC3)
  IF ferr% = 0 then call mlwrite(pgmnr%)
  IF ferr% = 0 then call mlread(cmd%)
  IF cmd% = &HC3 then call mlread(dat%) else ferr% = cmd%
  IF ferr% = 0 then FNmlpgmvorhanden% = dat%
  ferr1% = ferr%

END DEF

' Melden der Nummer eines Programms, das unter der angegebenen Task installiert ist

DEF FNmlmeldepgm%(ferr1%,tasknr%)
LOCAL cmd%,dat1%
SHARED ferr%

  dat1% = 0                                          ' Default = 0
  IF ferr% = 0 then call mlwrite(&HC4)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlread(cmd%)	             ' Zurueckgesendeter Befehlscode
  IF cmd% = &HC4 then call mlread(dat1%)_            ' Tasknummer
  ELSE ferr% = cmd%
  IF ferr% = 0 then call mlread(dat1%)               ' Programmnummmer
  IF ferr% = 0 then FNmlmeldepgm% = dat1%
  ferr1% = ferr%

END DEF

' Starten einer Prozedur einer Task

SUB mlrunproc(ferr1%,tasknr%,proc%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HC5)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(proc%)              ' Nummer der Prozedur
  ferr1% = ferr%

END SUB

' Pointer fuer Datenbereich setzen

SUB mlsetdatpoint(ferr1%,tasknr%,adr%)
SHARED ferr%

  IF adr% = 0 then
    IF ferr% = 0 then call mlwrite(&HC6)             ' Befehlscode
    IF ferr% = 0 then call mlwrite(tasknr%)          ' Tasknummer
  ELSE
    IF ferr% = 0 then call mlwrite(&HC7)             ' Befehlscode
    IF ferr% = 0 then call mlwrite(tasknr%)          ' Tasknummer
    IF ferr% = 0 then call mlwrite(adr% mod 256)     ' Adresse (Low)
    IF ferr% = 0 then call mlwrite(int(adr% / 256))  ' Adresse (High)
  END IF
  ferr1% = ferr%

END SUB

' Lese Byte von Pointer (Task) lesen und inkrement Pointer

DEF FNmlgetbytetask%(ferr1%,tasknr%)
LOCAL bite%,cmd%
SHARED ferr%

  bite% = 0                                          ' Default = 0
  IF ferr% = 0 then call mlwrite(&HC8)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlread(cmd%)                ' Zurueckgesendeter Befehlscode
  IF cmd% = &HC8 then call mlread(bite%)_            ' Tasknummer
  ELSE ferr% = cmd%
  IF ferr% = 0 then call mlread(bite%)               ' Daten
  FNmlgetbytetask% = bite%
  ferr1% = ferr%

END DEF

' Schreibe Byte an Pointer (Task) und inkrement Pointer

SUB mlsetbytetask(ferr1%,tasknr%,daten%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HC9)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(daten%)             ' Daten
  ferr1% = ferr%

END SUB

' Datenwort einer Task lesen

DEF FNmlgetinttask%(ferr1%,tasknr%)
LOCAL bite%,cmd%,int1%,int2%
SHARED ferr%

  int1% = 0 : int2% = 0                              ' Default = 0
  IF ferr% = 0 then call mlwrite(&HCA)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlread(cmd%)		     ' Zurueckgesendeter Befehlscode
  IF cmd% = &HCA then call mlread(bite%)_            ' Tasknummer
  ELSE ferr% = cmd%
  IF ferr% = 0 then call mlread(int2%)               ' Datenwort (Low)
  IF ferr% = 0 then call mlread(int1%)               ' Datenwort (High)
  z& = int1%

  FNmlgetinttask% = FNbyteint%(int1%,int2%)
  ferr1% = ferr%

END DEF

' Datenwort einer Task setzen

SUB mlsetinttask(ferr1%,tasknr%,daten%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HCB)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(daten% mod 256)     ' Datenwort (Low)
  IF ferr% = 0 then call mlwrite(int(daten% / 256))  ' Datenwort (High)
  ferr1% = ferr%

END SUB

' Block von Daten lesen

SUB mltaskblockread(ferr1%,tasknr%,zahl&,daten%(1))
LOCAL i&,cmd%,dat1%,dat2%,z&
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HD0)
  IF ferr% = 0 then call mlwrite(tasknr%)
  z& = int(zahl& / 256)
  IF ferr% = 0 then call mlwrite(zahl&-z&*256)
  IF ferr% = 0 then call mlwrite(int(zahl& / 256))
  IF ferr% = 0 then call mlread(cmd%)
  IF cmd% <> &HD0 then ferr% = cmd%_
  ELSE
    call mlread(dat1%)
    IF (dat1% = tasknr%) and (ferr% = 0) then
      i& = 0
      while (ferr% = 0) and (i& < int(zahl& / 2))
        i& = i& + 1
        call mlread(dat1%)
        call mlread(dat2%)
        daten%(i&) = FNbyteint%(dat2%,dat1%)
      wend
    END IF
  ferr1% = ferr%

END SUB

' Block von Daten schreiben

SUB mltaskblockwrite(ferr1%,tasknr%,zahl&,daten%(1))
LOCAL i&
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HD1)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  z& = (zahl& / 256)
  IF ferr% = 0 then call mlwrite(zahl&-z&*256)       ' Anzahl (Low)
  IF ferr% = 0 then call mlwrite(int(zahl& / 256))   ' Anzahl (High)
  i& = 0
  while (ferr% = 0) and (i& < int(zahl& / 2))
    i& = i& + 1
    call mlwrite(daten%(i&) mod 256)                 ' Daten senden
    call mlwrite(int(daten%(i&) / 256))              ' Daten senden
  wend
  ferr1% = ferr%

END SUB

' Parameter (Byte) einer Task lesen

DEF FNmlgetparbytetask%(ferr1%,tasknr%,parnr%)
LOCAL bite%,cmd%
SHARED ferr%

  bite% = 0                                          ' Default = 0
  IF ferr% = 0 then call mlwrite(&HCC)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlread(cmd%)                ' Zurueckgesendeter Befehlscode
  IF cmd% = &HCC then call mlread(bite%)             ' Tasknummer
  IF ferr% = 0 then call mlread(bite%)               ' Parameterwert
  FNmlgetparbytetask% = bite%
  ferr1% = ferr%

END DEF

' Parameter (Byte) einer Task setzen

SUB mlsetparbytetask(ferr1%,tasknr%,parnr%,parameter%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HCD)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlwrite(parameter%)         ' Parameterwert
  ferr1% = ferr%

END SUB

' Parameter (Wort) einer Task lesen

DEF FNmlgetparworttask%(ferr1%,tasknr%,parnr%)
LOCAL dat1%,dat2%,cmd%
SHARED ferr%

  dat1% = 0 : dat2% = 0                              ' Default = 0
  IF ferr% = 0 then call mlwrite(&HCE)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlread(cmd%)                ' Zurueckgesendeter Befehlscode
  IF cmd% = &HCE then call mlread(dat1%)_            ' Tasknummer
  ELSE ferr% = cmd%
  IF ferr% = 0 then call mlread(dat1%)               ' Parameterwert (Low)
  IF ferr% = 0 then call mlread(dat2%)               ' Parameterwert (High)
  IF ferr% = 0 then_
    FNmlgetparworttask% = FNbyteint%(dat2%,dat1%)
  ferr1% = ferr%

END DEF

' Parameter (Wort) einer Task setzen

SUB mlsetparworttask(ferr1%,tasknr%,parnr%,parameter%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HCF)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(tasknr%)            ' Tasknummer
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlwrite(parameter% mod 256) ' Parameterwert (Low)
  IF ferr% = 0 then call mlwrite(int(parameter% / 256)) ' Parameterwert (High)
  ferr1% = ferr%

END SUB

' Zugriff auf Daten und Parameter mit Vorwahl der Task-Nr.

' Anwahl einer Task

SUB mlwaehletask(ferr1%,tasknr%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HD4)
  IF ferr% = 0 then call mlwrite(tasknr%)
  ferr1% = ferr%

END SUB

' Starten einer Prozedur einer Task

SUB mldrunproc(ferr1%,proc%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HD5)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(proc%)              ' Nummer der Prozedur
  ferr1% = ferr%

END SUB

' Pointer fuer Datenbereich setzen

SUB mldsetdatpoint(ferr1%,adr%)
SHARED ferr%

  IF adr% = 0 then
    IF ferr% = 0 then call mlwrite(&HD6)             ' Befehlscode
  ELSE
    IF ferr% = 0 then call mlwrite(&HD7)             ' Befehlscode
    IF ferr% = 0 then call mlwrite(adr% mod 256)     ' Adresse (Low)
    IF ferr% = 0 then call mlwrite(int(adr% / 256))  ' Adresse (High)
  END IF
  ferr1% = ferr%

END SUB

' Lese Byte von Pointer (Task) lesen und inkrement Pointer

DEF FNmldgetbytetask%(ferr1%)
LOCAL bite%,cmd%
SHARED ferr%

  bite% = 0                                          ' Default = 0
  IF ferr% = 0 then call mlwrite(&HD8)               ' Befehlscode
  IF ferr% = 0 then call mlread(cmd%)                ' Zurueckgesendeter Befehlscode
  IF cmd% = &HD8 then call mlread(bite%)_            ' Datenbyte
  ELSE ferr% = cmd%
  FNmldgetbytetask% = bite%
  ferr1% = ferr%

END DEF

' Schreibe Byte an Pointer (Task) und inkrement Pointer

SUB mldsetbytetask(ferr1%,daten%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HD9)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(daten%)             ' Datenbyte
  ferr1% = ferr%

END SUB

' Datenwort einer Task lesen

DEF FNmldgetinttask%(ferr1%)
LOCAL cmd%,int1%,int2%
SHARED ferr%

  int1% = 0 : int2% = 0                              ' Default = 0
  IF ferr% = 0 then call mlwrite(&HDA)               ' Befehlscode
  IF ferr% = 0 then call mlread(cmd%)		     ' Zurueckgesendeter Befehlscode
  IF cmd% = &HDA then call mlread(int2%)_            ' Datenwort (Low)
  ELSE ferr% = cmd%
  IF ferr% = 0 then call mlread(int1%)               ' Datenwort (High)
  FNmldgetinttask% = FNbyteint%(int1%,int2%)
  ferr1% = ferr%

END DEF

' Datenwort einer Task setzen

SUB mldsetinttask(ferr1%,daten%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HDB)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(daten% mod 256)     ' Datenwort (Low)
  IF ferr% = 0 then call mlwrite(int(daten% / 256))  ' Datenwort (High)
  ferr1% = ferr%

END SUB

' Parameter (Byte) einer Task lesen

DEF FNmldgetparbytetask%(ferr1%,parnr%)
LOCAL bite%,cmd%
SHARED ferr%

  bite% = 0                                          ' Default = 0
  IF ferr% = 0 then call mlwrite(&HDC)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlread(cmd%)                ' Zurueckgesendeter Befehlscode
  IF cmd% = &HDC then call mlread(bite%)             ' Parameterwert
  FNmldgetparbytetask% = bite%
  ferr1% = ferr%

END DEF

' Parameter (Byte) einer Task setzen

SUB mldsetparbytetask(ferr1%,parnr%,parameter%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HDD)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlwrite(parameter%)         ' Parameterwert
  ferr1% = ferr%

END SUB

' Parameter (Wort) einer Task lesen

DEF FNmldgetparworttask%(ferr1%,parnr%)
LOCAL dat1%,dat2%,cmd%
SHARED ferr%

  dat1% = 0 : dat2% = 0                              ' Default = 0
  IF ferr% = 0 then call mlwrite(&HDE)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlread(cmd%)                ' Zurueckgesendeter Befehlscode
  IF cmd% = &HDE then call mlread(dat1%)_            ' Parameterwert (Low)
  ELSE ferr% = cmd%
  IF ferr% = 0 then call mlread(dat2%)               ' Parameterwert (High)
  IF ferr% = 0 then_
    FNmldgetparworttask% = FNbyteint%(dat2%,dat1%)
  ferr1% = ferr%

END DEF

' Parameter (Wort) einer Task setzen

SUB mldsetparworttask(ferr1%,parnr%,parameter%)
SHARED ferr%

  IF ferr% = 0 then call mlwrite(&HDF)               ' Befehlscode
  IF ferr% = 0 then call mlwrite(parnr%)             ' rel. Adresse Parameter
  IF ferr% = 0 then call mlwrite(parameter% mod 256) ' Parameterwert (Low)
  IF ferr% = 0 then call mlwrite(int(parameter% / 256)) ' Parameterwert (High)
  ferr1% = ferr%

END SUB

