unit task_lib;            (* Turbo PASCAL 4.0, 5.0, 5.5 spezifisch *)

interface                 (* Turbo PASCAL 4.0, 5.0, 5.5 spezifisch *)
  uses mlab_lib;          (* Turbo PASCAL 4.0, 5.0, 5.5 spezifisch *)

{.pl72}

{-------------------------------------------------------------------------------------------------}

(* Multi-Tasking Befehle *)

(* Bibliothek fr die Taskbefehle der Multi-LAB Karte *)

(*
  Bibliothek als Unit fr Turbo PASCAL Version 4.0, 5.0, 5.5

  Durch Weglassen der Turbo PASCAL 4.0, 5.0, 5.5 spezifischen Anweisungne
  (entsprechend gekennzeichnet) auch fr Turbo PASCAL 3.0 verwendbar

*)

(* Letzte Bearbeitung: 22.08.89  14:15 *)

type arr = array[1..1] of byte; (* dimensionierbar durch den Anwender *)

(* Interfacedefinition der Prozeduren und Funktionen *)

(* Turbo PASCAL 4.0, 5.0, 5.5 spezifisch *)

procedure mlinsttask(var err1 : byte;tasknr,pgmnr : byte;daten : integer);
procedure mlinstramtask(var err1 : byte;tasknr : byte;adr,daten : integer);
procedure mlverbindetask(var err1 : byte;tasknr1,tasknr2 : byte);
procedure mlloeschetask(var err1 : byte;tasknr : byte);
procedure mlrunproc(var err1 : byte;tasknr,proc : byte);
procedure mlsetdatpoint(var err1 : byte;tasknr : byte;adr : integer);
procedure mlsetbytetask(var err1 : byte;tasknr,daten : byte);
procedure mlsetinttask(var err1 : byte;tasknr : byte;daten : integer);
procedure mltaskblockread(var err1 : byte;tasknr : byte;zahl : integer;var daten : arr);
procedure mltaskblockwrite(var err1 : byte;tasknr : byte;zahl : integer;daten : arr);
procedure mlsetparbytetask(var err1 : byte;tasknr,parnr,parameter : byte);
procedure mlsetparworttask(var err1 : byte;tasknr,parnr : byte;parameter : integer);
procedure mlwaehletask(var err1 : byte;tasknr : byte);
procedure mldrunproc(var err1 : byte;proc : byte);
procedure mldsetdatpoint(var err1 : byte;adr : integer);
procedure mldsetbytetask(var err1 : byte;daten : byte);
procedure mldsetinttask(var err1 : byte;daten : integer);
procedure mldsetparbytetask(var err1 : byte;parnr,parameter : byte);
procedure mldsetparworttask(var err1 : byte;parnr : byte;parameter : integer);

function mlpgmvorhanden(var err1 : byte;pgmnr : byte) : byte;
function mlmeldepgm(var err1 : byte;tasknr : byte) : byte;
function mlgetbytetask(var err1 : byte;tasknr : byte) : byte;
function mlgetinttask(var err1 : byte;tasknr : byte) : integer;
function mlgetparbytetask(var err1 : byte;tasknr,parnr : byte) : byte;
function mlgetparworttask(var err1 : byte;tasknr,parnr : byte) : integer;
function mldgetbytetask(var err1 : byte) : byte;
function mldgetinttask(var err1 : byte) : integer;
function mldgetparbytetask(var err1 : byte;parnr : byte) : byte;
function mldgetparworttask(var err1 : byte;parnr : byte) : integer;

implementation            (* Turbo PASCAL 4.0, 5.0, 5.5 spezifisch *)

(* Installieren einer Task im ROM *)

procedure mlinsttask(var err1 : byte;tasknr,pgmnr : byte;daten : integer);
begin
  mlwrite($C0);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(pgmnr);                          (* Programmnummer *)
          if err = 0 then
            begin
              mlwrite(0);                          (* Dummy *)
              if err = 0 then
                begin
                  mlwrite(lo(daten));              (* Groesse Datenbereich (Low) *)
                  if err = 0 then
                    begin
                      mlwrite(hi(daten));          (* Groesse Datenbereich (High) *)
                    end;
                end;
            end;
        end;
    end;
  err1 := err;
end;

(* Installieren einer Task im RAM *)

procedure mlinstramtask(var err1 : byte;tasknr : byte;adr,daten : integer);
begin
  mlwrite($C0);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(lo(adr));                        (* RAM-Adresse (Low) *)
          if err = 0 then
            begin
              mlwrite(hi(adr));                    (* RAM-Adresse (High) *)
              if err = 0 then
                begin
                  mlwrite(lo(daten));              (* Groesse Datenbereich (Low) *)
                  if err = 0 then
                    begin
                      mlwrite(hi(daten));          (* Groesse Datenbereich (High) *)
                    end;
                end;
            end;
        end;
    end;
  err1 := err;
end;

(* Verbinden zweier Tasks *)

procedure mlverbindetask(var err1 : byte;tasknr1,tasknr2 : byte);
begin
  mlwrite($C1);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr1);                            (* Tasknummer *)
      if err = 0 then
        mlwrite(tasknr2);                          (* Tasknummer *)
    end;
  err1 := err;
end;

(* Loeschen einer Task *)

procedure mlloeschetask(var err1 : byte;tasknr : byte);
begin
  mlwrite($C2);
  if err = 0 then
    mlwrite(tasknr);
  err1 := err;
end;

(* Melde Programmnummer, wenn Programm vorhanden *)

function mlpgmvorhanden(var err1 : byte;pgmnr : byte) : byte;
var
   dat,cmd : byte;

begin
  mlwrite($C3);
  if err = 0 then
    begin
      mlwrite(pgmnr);
      if err = 0 then
        begin
          mlread(cmd);
          if cmd = $C3 then
            begin
              mlread(dat);
              if err = 0 then
                mlpgmvorhanden := dat;
            end
          else
            err := cmd;
        end;
    end;
  err1 := err;
end;

(* Melden der Nummer eines Programms, das unter der angegebenen Task installiert ist *)

function mlmeldepgm(var err1 : byte;tasknr : byte) : byte;
var
   cmd : byte;
   dat1 : byte;

begin
  mlwrite($C4);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlread(cmd);                             (* Zurueckgesendeter Befehlscode *)
          if cmd = $C4 then
            begin
              mlread(dat1);                        (* Tasknummer *)
              if err = 0 then
                begin
                  mlread(dat1);                    (* Programmnummmer *)
                  mlmeldepgm := dat1;
                end;
            end
          else
            err := cmd;
        end;
    end;
  err1 := err;
end;

(* Starten einer Prozedur einer Task *)

procedure mlrunproc(var err1 : byte;tasknr,proc : byte);
begin
  mlwrite($C5);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        mlwrite(proc);                             (* Nummer der Prozedur *)
    end;
  err1 := err;
end;

{-------------------------------------------------------------------------------------------------}

(* Pointer fuer Datenbereich setzen *)

procedure mlsetdatpoint(var err1 : byte;tasknr : byte;adr : integer);
begin
  if adr = 0 then
    begin
      mlwrite($C6);                                (* Befehlscode *)
      if err = 0 then
        mlwrite(tasknr);                           (* Tasknummer *)
    end
  else
    begin
      mlwrite($C7);                                (* Befehlscode *)
      if err = 0 then
        begin
          mlwrite(tasknr);                         (* Tasknummer *)
          if err = 0 then
            begin
              mlwrite(lo(adr));                    (* Adresse (Low) *)
              if err = 0 then
                mlwrite(hi(adr));                  (* Adresse (High) *)
            end;
        end;
    end;
  err1 := err;
end;

(* Datenbyte einer Task lesen *)

function mlgetbytetask(var err1 : byte;tasknr : byte) : byte;
var
   bite,cmd : byte;
begin
  mlwrite($C8);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlread(cmd);                             (* Zurueckgesendeter Befehlscode *)
          if cmd = $C8 then
            begin
              mlread(bite);                        (* Tasknummer *)
              if err = 0 then
                begin
                  mlread(bite);                    (* Datenbyte *)
                  mlgetbytetask := bite;
                end;
            end
          else
            err := cmd;
        end;
    end;
  err1 := err;
end;

(* Datenbyte einer Task setzen *)

procedure mlsetbytetask(var err1 : byte;tasknr,daten : byte);
begin
  mlwrite($C9);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        mlwrite(daten);                            (* Datenbyte *)
    end;
  err1 := err;
end;

(* Datenwort einer Task lesen *)

function mlgetinttask(var err1 : byte;tasknr : byte) : integer;
var
   bite,cmd : byte;
   int1,int : integer;

begin
  mlwrite($CA);                                   (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                            (* Tasknummer *)
      if err = 0 then
        begin
          mlread(cmd);                            (* Zurueckgesendeter Befehlscode *)
          if cmd = $CA then
            begin
              mlread(bite);                       (* Tasknummer *)
              if err = 0 then
                begin
                  mlread(bite);                   (* Datenwort (Low) *)
                  int := bite;
                  if err = 0 then
                    begin
                      mlread(bite);               (* Datenwort (High) *)
                      int1 := bite;
                      mlgetinttask := int1 * 256 + int;
                    end;
                end;
            end
          else
            err := cmd;
        end;
    end;
  err1 := err;
end;

(* Datenwort einer Task setzen *)

procedure mlsetinttask(var err1 : byte;tasknr : byte;daten : integer);
begin
  mlwrite($CB);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(lo(daten));                      (* Datenwort (Low) *)
          if err = 0 then
            mlwrite(hi(daten));                    (* Datenwort (High) *)
        end;
    end;
  err1 := err;
end;

{-------------------------------------------------------------------------------------------------}

(* Block von Daten lesen *)

procedure mltaskblockread(var err1 : byte;tasknr : byte;zahl : integer;var daten : arr);
var
   i : integer;
   cmd,dat1,dat2 : byte;

begin
  mlwrite($D0);
  if err = 0 then
    begin
      mlwrite(tasknr);
      if err = 0 then
        begin
          mlwrite(lo(zahl));
          if err = 0 then
            begin
              mlwrite(hi(zahl));
              if err = 0 then
                begin
                  mlread(cmd);
                  if cmd = $D0 then
                    begin
                      mlread(dat1);
                      if (dat1 = tasknr) and (err = 0) then
                        begin
                          i := 0;
                          while (err = 0) and (i < zahl) do
                            begin
                              i := i + 1;
                              mlread(daten[i]);
                            end;
                        end;
                    end
                  else
                    err := cmd;
                end;
            end;
        end;
    end;
  err1 := err;
end;

(* Block von Daten schreiben *)

procedure mltaskblockwrite(var err1 : byte;tasknr : byte;zahl : integer;daten : arr);
var
   i : integer;

begin
  mlwrite($D1);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(lo(zahl));                       (* Anzahl (Low) *)
          if err = 0 then
            begin
              mlwrite(hi(zahl));                   (* Anzahl (High) *)
              i := 0;
              while (err = 0) and (i < zahl) do
                begin
                  i := i + 1;
                  mlwrite(daten[i]);               (* Datenbytes *)
                end;
            end;
        end;
    end;
  err1 := err;
end;

{-------------------------------------------------------------------------------------------------}

(* Parameter (Byte) einer Task lesen *)

function mlgetparbytetask(var err1 : byte;tasknr,parnr : byte) : byte;
var
   bite,cmd : byte;
begin
  mlwrite($CC);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(parnr);                         (* rel. Adresse Parameter *)
          if err = 0 then
            begin
              mlread(cmd);                         (* Zurueckgesendeter Befehlscode *)
              if cmd = $CC then
                begin
                  mlread(bite);                    (* Tasknummer *)
                  if err = 0 then
                    begin
                      mlread(bite);                (* Parameterwert *)
                      mlgetparbytetask := bite;
                    end;
                end
              else
                err := cmd;
            end;
        end;
    end;
  err1 := err;
end;

(* Parameter (Byte) einer Task setzen *)

procedure mlsetparbytetask(var err1 : byte;tasknr,parnr,parameter : byte);
begin
  mlwrite($CD);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(parnr);                         (* rel. Adresse Parameter *)
          if err = 0 then
            mlwrite(parameter);                    (* Parameterwert *)
        end;
    end;
  err1 := err;
end;

(* Parameter (Wort) einer Task lesen *)

function mlgetparworttask(var err1 : byte;tasknr,parnr : byte) : integer;
var
   dat1,dat2,cmd : byte;
   wort : integer;
begin
  mlwrite($CE);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(parnr);                         (* rel. Adresse Parameter *)
          if err = 0 then
            begin
              mlread(cmd);                         (* Zurueckgesendeter Befehlscode *)
              if cmd = $CE then
                begin
                  mlread(dat1);                    (* Tasknummer *)
                  if err = 0 then
                    begin
                      mlread(dat1);                (* Parameterwert (Low) *)
                      if err =  0 then
                        begin
                          mlread(dat2);            (* Parameterwert (High) *)
                          if err = 0 then
                            begin
                              wort := dat2;
                              wort := wort * 256 + dat1;
                              mlgetparworttask := wort;
                            end;
                        end;
                    end;
                end
              else
                err := cmd;
            end;
        end;
    end;
  err1 := err;
end;

(* Parameter (Wort) einer Task setzen *)

procedure mlsetparworttask(var err1 : byte;tasknr,parnr : byte;parameter : integer);
begin
  mlwrite($CF);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(tasknr);                             (* Tasknummer *)
      if err = 0 then
        begin
          mlwrite(parnr);                         (* rel. Adresse Parameter *)
          if err = 0 then
            begin
              mlwrite(lo(parameter));              (* Parameterwert (Low) *)
              if err = 0 then
                mlwrite(hi(parameter));            (* Parameterwert (High) *)
            end;
        end;
    end;
  err1 := err;
end;

{-------------------------------------------------------------------------------------------------}

(* Zugriff auf Daten und Parameter mit Vorwahl der Task-Nr. *)


(* Anwahl einer Task *)

procedure mlwaehletask(var err1 : byte;tasknr : byte);
begin
  mlwrite($D4);
  if err = 0 then
    mlwrite(tasknr);
  err1 := err;
end;

(* Starten einer Prozedur einer Task *)

procedure mldrunproc(var err1 : byte;proc : byte);
begin
  mlwrite($D5);                                    (* Befehlscode *)
  if err = 0 then
    mlwrite(proc);                                 (* Nummer der Prozedur *)
  err1 := err;
end;

(* Pointer fuer Datenbereich setzen *)

procedure mldsetdatpoint(var err1 : byte;adr : integer);
begin
  if adr = 0 then
    mlwrite($D6)                                   (* Befehlscode *)
  else
    begin
      mlwrite($D7);                                (* Befehlscode *)
      if err = 0 then
        begin
          mlwrite(lo(adr));                        (* Adresse (Low) *)
          if err = 0 then
            mlwrite(hi(adr));                      (* Adresse (High) *)
        end;
    end;
  err1 := err;
end;

(* Datenbyte einer Task lesen *)

function mldgetbytetask(var err1 : byte) : byte;
var
   bite,cmd : byte;
begin
  mlwrite($D8);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlread(cmd);                                 (* Zurueckgesendeter Befehlscode *)
      if cmd = $D8 then
        begin
          mlread(bite);                            (* Datenbyte *)
          mldgetbytetask := bite;
        end
      else
        err := cmd;
    end;
  err1 := err;
end;

(* Datenbyte einer Task setzen *)

procedure mldsetbytetask(var err1 : byte;daten : byte);
begin
  mlwrite($D9);                                    (* Befehlscode *)
  if err = 0 then
    mlwrite(daten);                                (* Datenbyte *)
  err1 := err;
end;

(* Datenwort einer Task lesen *)

function mldgetinttask(var err1 : byte) : integer;
var
   bite,cmd : byte;
   int1,int : integer;

begin
  mlwrite($DA);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlread(cmd);                                 (* Zurueckgesendeter Befehlscode *)
      if cmd = $DA then
        begin
          mlread(bite);                            (* Datenwort (Low) *)
          int := bite;
          if err = 0 then
            begin
              mlread(bite);                        (* Datenwort (High) *)
              int1 := bite;
              mldgetinttask := int1 * 256 + int;
            end;
        end
      else
        err := cmd;
    end;
  err1 := err;
end;

(* Datenwort einer Task setzen *)

procedure mldsetinttask(var err1 : byte;daten : integer);
begin
  mlwrite($DB);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(lo(daten));                          (* Datenwort (Low) *)
      if err = 0 then
        mlwrite(hi(daten));                        (* Datenwort (High) *)
    end;
  err1 := err;
end;

{-------------------------------------------------------------------------------------------------}

(* Parameter (Byte) einer Task lesen *)

function mldgetparbytetask(var err1 : byte;parnr : byte) : byte;
var
   bite,cmd : byte;
begin
  mlwrite($DC);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(parnr);                             (* rel. Adresse Parameter *)
      if err = 0 then
        begin
          mlread(cmd);                             (* Zurueckgesendeter Befehlscode *)
          if cmd = $DC then
            begin
              mlread(bite);                        (* Parameterwert *)
              mldgetparbytetask := bite;
            end
          else
            err := cmd;
        end;
    end;
  err1 := err;
end;

(* Parameter (Byte) einer Task setzen *)

procedure mldsetparbytetask(var err1 : byte;parnr,parameter : byte);
begin
  mlwrite($DD);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(parnr);                             (* rel. Adresse Parameter *)
      if err = 0 then
        mlwrite(parameter);                        (* Parameterwert *)
    end;
  err1 := err;
end;

(* Parameter (Wort) einer Task lesen *)

function mldgetparworttask(var err1 : byte;parnr : byte) : integer;
var
   dat1,dat2,cmd : byte;
   wort : integer;
begin
  mlwrite($DE);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(parnr);                             (* rel. Adresse Parameter *)
      if err = 0 then
        begin
          mlread(cmd);                             (* Zurueckgesendeter Befehlscode *)
          if cmd = $DE then
            begin
              mlread(dat1);                        (* Parameterwert (Low) *)
              if err =  0 then
                begin
                  mlread(dat2);                    (* Parameterwert (High) *)
                  if err = 0 then
                    begin
                      wort := dat2;
                      wort := wort * 256 + dat1;
                      mldgetparworttask := wort;
                    end;
                end;
            end
          else
            err := cmd;
        end;
    end;
  err1 := err;
end;

(* Parameter (Wort) einer Task setzen *)

procedure mldsetparworttask(var err1 : byte;parnr : byte;parameter : integer);
begin
  mlwrite($DF);                                    (* Befehlscode *)
  if err = 0 then
    begin
      mlwrite(parnr);                             (* rel. Adresse Parameter *)
      if err = 0 then
        begin
          mlwrite(lo(parameter));                  (* Parameterwert (Low) *)
          if err = 0 then
            mlwrite(hi(parameter));                (* Parameterwert (High) *)
        end;
    end;
  err1 := err;
end;

{-------------------------------------------------------------------------------------------------}

end.                      (* Turbo PASCAL 4.0, 5.0, 5.5 spezifisch *)
